
------------------------------------------------------------------------------------------------------------
------------------------------- Step 2/2: Run After run Step 1
-------------------------------           
------------------------------------------------------------------------------------------------------------

USE _ConfigDB_x

DECLARE @PCINTERFACE_NUMBER varchar(10)
set @PCINTERFACE_NUMBER = '148'+':'

-- Update Virt Instr Name
--
update virtualinstruments set virtualinstruments.Name = virtualinstruments_OLD.Name
From virtualinstruments_OLD ,virtualinstruments 
where virtualinstruments_OLD.Notes = virtualinstruments.Notes


--Restore Virt Resources Name
--
update dbo.VirtualResources 
set Name = VRC.VRNAme
from dbo.VirtualResources VR,dbo.VRNameChanged VRC,dbo.VirtualInstruments VI
where VI.ID_VirtualInstrument = VR.Ref_IDVirtualInstr
AND SUBSTRING(REPLACE(VI.NAME,@PCINTERFACE_NUMBER,''),1,5)=VRC.ADDRESS
AND VR.ResourceType=VRC.ResourceType
AND VR.EventAlarmCode=VRC.EventAlarmCode

-- Update Virt Res Alarm Delay
--
update dbo.VirtualResources 
set AlmDelayIn = VRC.AlmDelayIn,AlmDelayOut = VRC.AlmDelayOut
from dbo.VirtualResources VR,dbo.VRAlmDelayChanged VRC,dbo.VirtualInstruments VI
where VI.ID_VirtualInstrument = VR.Ref_IDVirtualInstr
AND SUBSTRING(REPLACE(VI.NAME,@PCINTERFACE_NUMBER,''),1,5)=VRC.ADDRESS
AND VR.ResourceType=VRC.ResourceType
AND VR.EventAlarmCode=VRC.EventAlarmCode

GO
