------------------------------------------------------------------
------------------------------------------------------------------
-- Author:
-- Date:
-- Notes: Script non compatible with OLEDB if GO is present to
--        separate batch. GO must be placed  before CREATE statements.
--
--
------------------------------------------------------------------
------------------------------------------------------------------


------------------------------------------------------------------
---------------------------- TWIN DB -----------------------------
------------------------------------------------------------------


-- place customom SQL And DDL for upgrade here (place GO before CREATE statements) 

USE TwinDB


-- aggiornamento della modulesStrings con stringhe nuove
DELETE FROM ModulesStrings WHERE IDDictionary = 776
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(776,0,'1-0776','Configurazione rete',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(776,34,'Duracin alm entr (s)','Configurazione rete',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(776,39,'Durata all. entr. (s)','Configurazione rete',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(776,44,'Incom alm delay (s)','Configurazione rete',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 777
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(777,0,'1-0777','Configurazione rete',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(777,34,'Duracin alm sal. (s)','Configurazione rete',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(777,39,'Durata all. usc. (s)','Configurazione rete',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(777,44,'Outcom alm delay (s)','Configurazione rete',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 778
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(778,0,'1-0778','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(778,34,'Retardo para envo fax (s)','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(778,39,'Ritardo invio notifiche fax (s)','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(778,44,'Fax notification delay (s)','Configurazione sms/fax',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 779
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(779,0,'1-0779','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(779,34,'Retardo para envo SMS (s)','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(779,39,'Ritardo invio notifiche sms (s)','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(779,44,'SMS notification delay (s)','Configurazione sms/fax',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 780
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(780,0,'1-0780','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(780,34,'Retardo para envo e-mail(s)','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(780,39,'Ritardo invio notifiche e-mail (s)','Configurazione sms/fax',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(780,44,'E-mail  notification delay (s)','Configurazione sms/fax',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 781
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(781,0,'1-0781','Salvataggio configurazione RDM',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(781,34,'El mdem fax no est instalado correcteamente','Salvataggio configurazione RDM',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(781,39,'Il modem Fax non  correttamente installato','Salvataggio configurazione RDM',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(781,44,'The Fax modem is not correctly installed','Salvataggio configurazione RDM',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 782
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(782,0,'1-0782','Salvataggio configurazione RDM',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(782,34,'El mdem GSM no est instalado correctamente','Salvataggio configurazione RDM',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(782,39,'Il modem GSM non  correttamente installato','Salvataggio configurazione RDM',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(782,44,'The GSM  modem is not correctly installed','Salvataggio configurazione RDM',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 783
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(783,0,'1-0783','Tabellare',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(783,34,'Permitir modif. direccin red','Tabellare',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(783,39,'Abilita modifica indirizzo di rete','Tabellare',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(783,44,'Enable network address changes','Tabellare',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 784
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(784,0,'1-0784','Lista impianti',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(784,34,'El nombre de planta no puede contener los siguiente caracteres  ~  !  %  ^  &  (  )  -  {  }  "  .  \   ''','Lista impianti',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(784,39,'Il nome dell''impianto non pu contenere i seguenti caratteri:  ~  !  %  ^  &  (  )  -  {  }  "  .  \   ''','Lista impianti',1)
INSERT INTO [modulesstrings] ([IDDictionary],[IDLanguage],[StringText],[StringDescription],[IDModule])VALUES(784,44,'The plant name can not contain any of the following characters:  ~  !  %  ^  &  (  )  -  {  }  "  .  \   ''','Lista impianti',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 785
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (785,0,'1-0785','Titolo su scheduler stampe',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (785,34,'Tareas de impresin','Titolo su scheduler stampe',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (785,39,'Scheduler di stampa','Titolo su scheduler stampe',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (785,44,'Printer scheduler','Titolo su scheduler stampe',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 806
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (806,0,'1-0806','Avviso su accesso a configurazione RDM',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (806,34,'Es necesario detener las conexiones entrantes','Avviso su accesso a configurazione RDM',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (806,39,'E'' necessario fermare l''host mode prima di proseguire','Avviso su accesso a configurazione RDM',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (806,44,'It is necessary to stop host mode before proceeding','Avviso su accesso a configurazione RDM',1)


DELETE FROM ModulesStrings WHERE IDDictionary = 851
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (851,0,'1-0851','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (851,34,'Opciones de la base de datos','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (851,39,'Opzioni database','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (851,44,'Database options','Menu Programma del pannello di controllo',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 852
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (852,0,'1-0852','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (852,34,'Persistencia de los datos temporaneos (min)','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (852,39,'Persistenza dati temporanei (min)','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (852,44,'Temporary data guarantied (min)','Menu Programma del pannello di controllo',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 853
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (853,0,'1-0853','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (853,34,'Seleccionar carpeta de backup','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (853,39,'Cambia directory di backup','Menu Programma del pannello di controllo',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (853,44,'Change backup directory','Menu Programma del pannello di controllo',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 854
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (854,0,'1-0854','Errori su scarico dati da Compact',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (854,34,'Error: fallo en descarga de datos','Errori su scarico dati da Compact',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (854,39,'Errore: scarico dati fallito','Errori su scarico dati da Compact',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (854,44,'Error: download data failed','Errori su scarico dati da Compact',1)

DELETE FROM ModulesStrings WHERE IDDictionary = 855
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (855,0,'1-0855','Errori su scarico dati da Compact',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (855,34,'El ID de la conexin ya existe. Especifique otro.','Errori su registrazione nuovo Compact',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (855,39,'ID connessione gi esistente. Specificarne un altro.','Errori su registrazione nuovo Compact',1)
INSERT INTO ModulesStrings (IDDictionary, IDLanguage, StringText, StringDescription, IDModule) values (855,44,'Connection ID already existing. Type a new one.','Errori su registrazione nuovo Compact',1)


UPDATE ModulesStrings SET StringText = 'Il Televis NET locale  impegnato in una operazione non interrompibile. Riprovare pi tardi' WHERE IDDictionary=606 AND IDLanguage =39 AND IDModule=1
UPDATE ModulesStrings SET StringText = 'Local Televis NET is computing an uninterrumpable task. Please try later' WHERE IDDictionary=606 AND IDLanguage =44 AND IDModule=1
UPDATE ModulesStrings SET StringText = 'El Televis NET de la planta local est ocupado por un proceso no interrumpible. Reintente ms tarde' WHERE IDDictionary=606 AND IDLanguage =34 AND IDModule=1

GO



-- Aggiornamento dei Trigger e Stored procedure per referenziare DB Plants con la sintassi [DB plants] 
-- che permette di gestire qualsiasi nome di plant


-- PROCEDURA st_UpdateAlmViewFromPlants
--

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_UpdateAlmViewFromPlants]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_UpdateAlmViewFromPlants]
GO

CREATE   PROCEDURE [st_UpdateAlmViewFromPlants] AS

declare  crsPlants cursor for
	select PlantID, [Name],[description]  from plants

declare @PlantID int
declare @PlantName varchar(50)
declare @PlantDescr varchar(50)
declare @command varchar(8000)
declare @PIndex smallint
set @PIndex=0
set @PlantID = -1

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_AlmCfgFromPlants]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_AlmCfgFromPlants]

open crsPlants
fetch next from crsPlants into @PlantID,@PlantName,@PlantDescr

WHILE @@FETCH_STATUS = 0
	begin
		IF @PIndex=0
			BEGIN
				set @command='CREATE  VIEW [Vw_AlmCfgFromPlants] as ' + char(13)
			END
		ELSE
			BEGIN
				set @command=@command + char(13) + ' UNION ' + char(13)
			END
		set @command=@command +
			'SELECT ' + convert(varchar,@PlantID) + ' as PlantID,''' + 
			@PlantName + ' ' + isnull(replace (@PlantDescr, '''', ''''''),'') + ''' as PlantName, cfgbase.*
			FROM  [' + @PlantName +'cfgDB].dbo.Vw_VirtInstr_AlmsBase as CfgBASE '	

		set @PIndex=@PIndex+1

		fetch next from crsPlants into @PlantID,@PlantName,@PlantDescr
	end
CLOSE crsPlants
DEALLOCATE crsPlants

print @command
exec (@command)

GO



-- TRIGGER Plants_ITrig
--

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Plants_ITrig]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[Plants_ITrig]
GO

CREATE TRIGGER Plants_ITrig ON [dbo].[Plants] 
FOR insert
AS
BEGIN
-- alla insert vanno riportate le info di PlantID,PlantName e PlantType
-- sulla tabella  GenericSettings del plant

declare @PlantID as int
declare @PlantType as smallint
declare @PlantName as varchar(20)
declare @cmd varchar(500)

-- si sssume l'inserimento di una riga alla volta.
select @PlantID=PlantID,@PlantType=PlantType,@PlantName=[Name] from inserted

set @cmd = 'insert into [' + @PlantName + 'CfgDB].dbo.GenericSettings ([Name], SetValue) values (''PlantName'', ''' + @PlantName + ''')'
exec (@cmd)

set @cmd = 'insert into [' + @PlantName + 'CfgDB].dbo.GenericSettings ([Name], SetValue) values (''PlantType'', ''' + cast(@PlantType as char) + ''')'
exec (@cmd)

set @cmd = 'insert into [' + @PlantName + 'CfgDB].dbo.GenericSettings ([Name], SetValue) values (''PlantID'', ''' + cast(@PlantID as char) + ''')'
exec (@cmd)

if @PlantType = 1 
	BEGIN
		set @cmd = ' delete from [' + @PlantName + 'CfgDB].dbo.Networks'
		exec (@cmd)
		set @cmd = 'insert into [' + @PlantName + 'CfgDB].dbo.Networks (ID_Network, InterfacePort,Name,Description,ValidateStartDate,LastModifiedDate,StandbyFlag,InternalUpdate) values (1,1, ''' + @PlantName + ''', ''' + @PlantName + ''', ''' + convert(varchar,getdate()) + ''',''' + convert(varchar,getdate()) + ''', 0, 0)'
		exec (@cmd)
        set @cmd = '[' + @PlantName + 'CfgDB].dbo.st_UpdateVw_CompactVsTelevisAlm ''' +  @PlantName + 'AcqDB'''
		exec (@cmd)
	END
	
-- Aggiornamento delle vista 

	exec st_UpdateAlmViewFromPlants
END
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[RegisterPlant]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[RegisterPlant]
GO

CREATE  PROCEDURE [RegisterPlant] 	
	@PlantName as varchar(100),	
	@TwinDBName as varchar(100),
	@Path as varchar(500)
AS


DECLARE @dbNameCfg VARCHAR(100)
DECLARE @dbNameAcq VARCHAR(100)

DECLARE @cmd VARCHAR(256)

declare @sql as varchar(8000)

set @dbNameCfg=@PlantName + 'CfgDB'
set @dbNameAcq=@PlantName + 'AcqDB'

set @sql= 'CREATE DATABASE  ['+ @dbNameCfg +'] ON ( NAME = ''' + @dbNameCfg + '_dat''' +
          ',FILENAME = '''+ @Path + '\Database\' + @dbNameCfg + '.mdf''' + 
          ',SIZE=1MB , FILEGROWTH=5MB) ' +
          'LOG ON (NAME=''' + @dbNameCfg + '_log''' +
          ',FILENAME= '''+ @Path + '\Database\' + @dbNameCfg + '.ldf''' + 
	  ',SIZE=1MB, FILEGROWTH=5MB)'
EXEC (@sql)

if @@error<>0
	return 1

--exec master.dbo.sp_configure locks, 20000000 RECONFIGURE WITH OVERRIDE


set @sql= 'CREATE DATABASE  ['+ @dbNameAcq +'] ON ( NAME = ''' + @dbNameAcq + '_dat''' +
          ',FILENAME = '''+ @Path + '\Database\' + @dbNameAcq + '.mdf''' + 
          ',SIZE=1MB , FILEGROWTH=5MB) ' +
          'LOG ON (NAME=''' + @dbNameAcq + '_log''' +
          ',FILENAME= '''+ @Path + '\Database\' + @dbNameAcq + '.ldf''' + 
	  ',SIZE=1MB, FILEGROWTH=5MB)'
EXEC (@sql)

if @@error<>0
	return 2

--exec master.dbo.sp_configure locks, 20000000 RECONFIGURE WITH OVERRIDE


SET @cmd = 'osql.exe -U sa -P gusela -i "' + @Path + '\Database\Scripts\CreateConfigPlant.sql" -d "' + @dbNameCfg + '"'
EXECUTE master.dbo.xp_cmdshell @cmd, NO_OUTPUT
if @@error<>0
	    return 3

SET @cmd = 'osql.exe -U sa -P gusela -i "' + @Path + '\Database\Scripts\CreateAcqPlant.sql" -d "' + @dbNameAcq + '"'
EXECUTE master.dbo.xp_cmdshell @cmd, NO_OUTPUT
if @@error<>0
	    return 4

-- lancio la copia dei dati dai templates
set @sql= 'EXEC [' + @dbNameCfg + '].dbo.CopyDataFromTemplate _TemplateConfigDB_x'
exec (@sql)
if @@error<>0
	    return 5
	    
set @sql= 'EXEC [' + @dbNameAcq + '].dbo.CopyDataFromTemplate _TemplateAcquiredDB_x'
exec (@sql)
if @@error<>0
	    return 6
-- inserisco nella genericsetings del nuovo plant il nome del twin
set @sql='insert into [' + @dbNameCfg + '].dbo.GenericSettings (Name, SetValue) values (''TwinDBName'',''' + @TwinDBName + ''')'
exec (@sql)
if @@error<>0
	    return 7
	    
GO


---------------------------------------------------------------------
------------------------------------------ Procedure svecchiamento DB


/****** Object:  Stored Procedure dbo.st_BuildView_Vw_TwinFlashAlmsToSave    Script Date: 27/02/2004 10.55.54 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_BuildView_Vw_TwinFlashAlmsToSave]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_BuildView_Vw_TwinFlashAlmsToSave]
GO


CREATE             proc [st_BuildView_Vw_TwinFlashAlmsToSave]
@UpperDate datetime
as
/*
* PROCEDURE st_BuildView_Vw_TwinFlashAlmsToSave
* This StProc builds the view to save on disk data from FlashAlarms table on Twin database
* by the criteria 'TimeStamp < @Upperdate
*
* Parameters:	@UpperDate	reference end date for rows to get
*				
*
* RETURN CODES:	0	No Error
*	
* NOTES: Command string to execute can be very long, so we have to do a little trick,
* generating the command to a TEXT field in a temporary table, then retrieving it 8k chars at time,
* and appending each subcommand to the next for the final EXECUTE 
*/

declare  crsPlants cursor for
	select PlantID, [Name]  from plants

declare @MyCmd1 varchar(8000) -- about 1000 char for each plant, so we must get enough space for 80 plants using 10 variables
declare @MyCmd2 varchar(8000) 
declare @MyCmd3 varchar(8000) 
declare @MyCmd4 varchar(8000) 
declare @MyCmd5 varchar(8000) 
declare @MyCmd6 varchar(8000) 
declare @MyCmd7 varchar(8000) 
declare @MyCmd8 varchar(8000) 
declare @MyCmd9 varchar(8000) 
declare @MyCmd10 varchar(8000) 
declare @StrPos int
declare @CfgDBName varchar(128)
declare @CfgDBNameEXT varchar(128)
declare @PlantID int
declare @PlantName varchar(128)
declare @PIndex smallint
declare @ptrval binary(16)
set @PIndex=0
set @PlantID = -1

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_TwinFlashAlmsToSave]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_TwinFlashAlmsToSave]

create table #T_CMDTEXT (Command text)
insert #T_CMDTEXT (command) values('')
open crsPlants
fetch next from crsPlants into @PlantID,@PlantName

WHILE @@FETCH_STATUS = 0
	begin
		set @CfgDBName=@PlantName + 'CfgDB'
		set @CfgDBNameEXT=master.dbo.fc_GetRegularIdentifier(@CfgDBName)
		IF @PIndex=0
			BEGIN
				set @MyCmd1='CREATE  VIEW [Vw_TwinFlashAlmsToSave] as ' + char(13)
			END
		ELSE
			BEGIN
				set @MyCmd1=@MyCmd1 + char(13) + ' UNION ' + char(13)
			END
		set @MyCmd1=@MyCmd1 +
			'SELECT  top 100 percent '+
					'convert(varchar,FA.[Timestamp],120) as AlmTimeStamp,FA.Ref_Plantid as PlantID,''' +
					@PlantName  + ''' as PlantName,FA.Ref_VirtInstrumentID,  VI.[Name] AS InstrName,FA.AlarmCode, '+
					'FA.AlarmState, convert(decimal(15,2),FA.AlarmValue) as AlmValue, '+
					'FA.ExecStatus '+
			'FROM    dbo.FlashAlarms FA inner join ' + @CfgDBNameEXT + '.dbo.VirtualInstruments VI ON '+
					 'FA.Ref_VirtInstrumentID = VI.ID_VirtualInstrument and '+
					'FA.[timestamp]>= VI.validatestartdate '+
			'where FA.[timestamp]<''' + convert(varchar,@upperdate,101) + ''' and FA.Ref_Plantid='+ convert(varchar,@PlantID) + 
			' order by AlmTimeStamp ' + char(13)+
			'UNION ' +char(13)+
			'SELECT  top 100 percent ' +
					'convert(varchar,FA.[Timestamp],120) as AlmTimeStamp,FA.Ref_Plantid as PlantID,''' +
					@PlantName  +''' as PlantName, FA.Ref_VirtInstrumentID,  VI.[Name] AS InstrName,FA.AlarmCode, ' +
					'FA.AlarmState, convert(decimal(15,2),FA.AlarmValue) as AlmValue, '+
					'FA.ExecStatus '+ char(13)+
			'FROM    dbo.FlashAlarms FA inner join ' + @CfgDBNameEXT + '.dbo.Hist_VirtualInstruments VI ON ' +
					' FA.Ref_VirtInstrumentID = VI.ID_VirtualInstrument and '+
					'FA.[timestamp]between VI.validatestartdate and VI.validateenddate '+
			'where FA.[timestamp]<''' + convert(varchar,@upperdate,101) + '''and FA.Ref_Plantid='+ convert(varchar,@PlantID) + 
			' order by AlmTimeStamp'
--print @MyCmd1
		set @PIndex=@PIndex+1
				
		set @MyCmd1=@MyCmd1 + ' '
		SELECT top 1 @ptrval = TEXTPTR(command)  FROM #T_CMDTEXT
		UPDATETEXT #T_CMDTEXT.command @ptrval null 0 @MyCmd1
		
		--update #T_CMDTEXT set command=command + ' ' + @MyCmd1
		set @MyCmd1 =''

		fetch next from crsPlants into @PlantID,@PlantName
	end
CLOSE crsPlants
DEALLOCATE crsPlants

select @MyCmd1=substring(command,1,8000) from #T_CMDTEXT
select @MyCmd2=substring(command,8001,8000) from #T_CMDTEXT
select @MyCmd3=substring(command,16001,8000) from #T_CMDTEXT
select @MyCmd4=substring(command,24001,8000) from #T_CMDTEXT
select @MyCmd5=substring(command,32001,8000) from #T_CMDTEXT
select @MyCmd6=substring(command,40001,8000) from #T_CMDTEXT
select @MyCmd7=substring(command,48001,8000) from #T_CMDTEXT
select @MyCmd8=substring(command,56001,8000) from #T_CMDTEXT
select @MyCmd9=substring(command,64001,8000) from #T_CMDTEXT
select @MyCmd10=substring(command,72001,8000) from #T_CMDTEXT


--print  (@MyCmd1+@MyCmd2+@MyCmd3+@MyCmd4+@MyCmd5+@MyCmd6+@MyCmd7+@MyCmd8+@MyCmd9+@MyCmd10)
exec (@MyCmd1+@MyCmd2+@MyCmd3+@MyCmd4+@MyCmd5+@MyCmd6+@MyCmd7+@MyCmd8+@MyCmd9+@MyCmd10)

drop table #T_CMDTEXT

GO

/****** Object:  Stored Procedure dbo.st_TWINAcqDBCheckSizeSaveData    Script Date: 27/02/2004 10.27.14 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_TWINAcqDBCheckSizeSaveData]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_TWINAcqDBCheckSizeSaveData]
GO


CREATE                         proc st_TWINAcqDBCheckSizeSaveData
 @ACqDBName varchar(128),
 @CfgDBName varchar(128),
 @BackupDir varchar(256)
AS

/*
* PROCEDURE st_TWINAcqDBCheckSizeSaveData
* This StProc takes a series of actions which purpose is 
* to verify the size for ACQ Plant database and, if it is the case,
* to save requested old data to disk, Backup DBs and Truncate DB LOGs.
*
* Parameters:	@ACqDBName	Acquired plant DB Name
*				@CfgDBName	Config plant DB Name
*				@BackupDir	backup directory
*				
*
* RETURN CODES:	0	No Error
*				10	BackupDir is null 
*				11	Unable to create BackupDir on disk
*				13	Failed to Execute bcp shell
*				14	Failed to rename or append save data file on disk
*
* NOTES: We retrieve DB Sizes constants from custom UDFs stored in MASTER Database
* The criteria to delete oldest data is to get the oldest week data stored, starting from
* oldest TIMESTAMP for ACQ DBs (same for Data and Alarms), from
* oldest TIMESTAMP for TWIN DB (just for Alarms, having no data), from
* oldest ValidateEndDate for CFG DBs (same for all Hist_* config tables)
*/

declare @ACqDBNameEXT varchar(128)
declare @CfgDBNameEXT varchar(128)
declare @OldestHDDate datetime
declare @OldestFADate datetime
declare @OldestDate datetime
declare @UpperDateLimit datetime
declare @UpperDateLimit1 datetime
declare @DBSizeLimit dec(10,2)
--declare @BackupDir varchar(256)
declare @CurrentHDFile varchar(256)
declare @CurrentFAFile varchar(256)
declare @CurrentBackupFileName varchar(256)
declare @CurrentLogFileName varchar(256)
declare @Cmd varchar(4000)
declare @RetCode int
declare @DBSize dec(10,2)
declare @DummyInt int
declare @RecoveryModel varchar(20)

--set @ACqDBName='TWINAcqTest'
--set @CfgDBName='TWINCfgTest'
--set @ACqDBNameEXT= '[' + @ACqDBName + ']'
--set @CfgDBNameEXT= '[' + @CfgDBName + ']'

set @ACqDBNameEXT=master.dbo.fc_GetRegularIdentifier(@ACqDBName)
set @CfgDBNameEXT=master.dbo.fc_GetRegularIdentifier(@CfgDBName)

set @DBSizeLimit=master.dbo.fc_DefaultAcqDBSize()
set @RecoveryModel=convert(varchar,DatabasePropertyEx(@AcqDBNAme,'Recovery'))
create table #DBSIZETABLE (
	dbsize dec)
set @cmd='use ' + @ACqDBNameEXT
set @cmd=@Cmd + ' insert #DBSIZETABLE exec sp_UsedSpace'
--print @cmd
exec (@Cmd)
select @Dbsize=dbsize from #DBSIZETABLE
drop table #DBSIZETABLE
--print 'DBSIZE:' + convert(varchar,@Dbsize)
/*
set @Cmd='select setvalue into T_GENSETS from ' +@CfgDBName +'..Genericsettings 
		where [Name]=''backupdir'''
exec (@Cmd)

select top 1 @BackupDir=Setvalue from T_GENSETS
drop table T_GENSETS


select @BackupDir=setvalue  from TwinCfgTest..Genericsettings
		where [Name]='backupdir'
*/

if @BackupDir is null 
	return(10)
else
	BEGIN
		set @Cmd='dir "' + @BackupDir +'"'
		exec @RetCode=master..xp_cmdshell @Cmd,  no_output
		if @retCode<>0
			BEGIN
				set @Cmd='md "' + @BackupDir + '"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
				if @RetCode<>0 return(11)
			END
	END
				
	BEGIN

	create table #TEMPDIR (Nomefile varchar(256) null)
	set @Cmd='dir "' + @BackupDir + '\'+ @ACqDBName + '_?.bck" /b/od'
	--print @cmd
	insert #TEMPDIR exec master..xp_cmdshell @Cmd
/*
	select top 1 @CurrentBackupFileName=nomefile from #TEMPDIR
	if @CurrentBackupFileName=null then
		set @CurrentBackupFileName=@ACqDBName + '_1.bck'
	else if @CurrentBackupFileName=@ACqDBName + '_1.bck'
		set @CurrentBackupFileName=@ACqDBName + '_2.bck'
	else


	select top 1 nomefile from #TEMPDIR*/
	select @DummyInt=count(*) from #TEMPDIR where nomefile like @ACqDBName+'%'
	IF @DummyInt=0
		set @CurrentBackupFileName=@ACqDBName + '_1.bck'
	else if @DummyInt=1
		set @CurrentBackupFileName=@ACqDBName + '_2.bck'
	else
		select top 1 @CurrentBackupFileName=nomefile from #TEMPDIR
	
	drop table #TEMPDIR
		--Backup DB
		set @CurrentBackupFileName=@BackupDir + '\'+ @CurrentBackupFileName
		set @CurrentLogFileName= left(@CurrentBackupFileName,len(@CurrentBackupFileName)-3) + 'log'
		IF @RecoveryModel <> 'SIMPLE'
			BEGIN
				BACKUP LOG @AcqDBName TO DISK = @CurrentLogFileName	 WITH   DESCRIPTION = 'Automatic Televis Log',INIT
				BACKUP LOG @AcqDBName  WITH TRUNCATE_ONLY 
			END
		-- If DB size is OK, shrink and nothing else to do

		if @DBSize<@DBSizeLimit 
			BEGIN
				DBCC SHRINKDATABASE (@AcqDBName ,25,  NOTRUNCATE)
				return(0)
			END

		BACKUP DATABASE @AcqDBName TO DISK = @CurrentBackupFileName	 WITH   DESCRIPTION = 'Automatic Televis backup',INIT

		
		set @Cmd='select min(timestamp)as MinDate into T_DATES from  ' +@AcqDBNameEXT +'..Historicaldata' 
		exec (@Cmd)
		select top 1 @OldestHDDate=MinDate from T_DATES
		drop table T_DATES

		set @Cmd='select min(timestamp)as MinDate into T_DATES from  ' +@AcqDBNameEXT +'..FlashAlarms' 
		exec (@Cmd)
		select top 1 @OldestFADate=MinDate from T_DATES
		drop table T_DATES

		--select @OldestHDDate= min(timestamp) from Historicaldata
		--select @OldestFADate = min(timestamp) from FlashAlarms
		if @OldestHDDate<@OldestFADate
			set @oldestDate=isnull(@OldestHDDate,@OldestFADate)
		ELSE
			SET @oldestDate	=isnull(@OldestFADate,@OldestHDDate)
		set @Upperdatelimit=dateadd(d,7,@oldestDate)
		if datediff(m,@oldestDate,@Upperdatelimit)>0 --Finisce un mese e inizia quello seguente
			BEGIN
				SET @UpperDateLimit1=dateadd(d,-(day(@Upperdatelimit)-1),@Upperdatelimit)

	
		--HistoricalData		
				set @cmd=' exec ' + @AcqDBNameEXT +'.dbo.st_BuildView_Vw_HDataToSave '''+
							convert(varchar,@UpperDateLimit1,120) + ''','+ @CfgDBName 
				--print @cmd
				exec (@Cmd)
				set @Cmd='bcp "' + @AcqDBName + '..Vw_HDataToSave" out "'+
							@BackupDir + '\TempData.txt"  -c -q -t"|"  '
				exec @RetCode=master..xp_cmdshell @Cmd ,no_output
				if @RetCode<>0 return(13)

				set @UpperDateLimit1=dateadd(d,-1,@UpperDateLimit1) --just to generate correct file name
				set @DummyInt=month(@UpperDateLimit1)
				if @DummyInt <10
					BEGIN
						set @CurrentHDFile='HistData_'+ convert(char(4),year(@UpperDateLimit1))+
								'0' + convert(char(1),@DummyInt)+'.txt'
						set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit1))+
								'0' + convert(char(1),@DummyInt)+'.txt'
					END
				else
					BEGIN
						set @CurrentHDFile='HistData_'+ convert(char(4),year(@UpperDateLimit1))+
								 convert(char(2),@DummyInt)+'.txt'
						set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit1))+
								 convert(char(2),@DummyInt)+'.txt'
					END
				set @UpperDateLimit1=dateadd(d,1,@UpperDateLimit1)  --Correct date

--print @CurrentHDFile
				set @cmd='dir "' + @BackupDir + '\' + @CurrentHDFile + '"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
 				if @RetCode=0
					set @Cmd='copy "'+@BackupDir + '\' + @CurrentHDFile + '" + "' +	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentHDFile + '" /B'
				ELSe				
					set @Cmd='move "'+	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentHDFile +'"'
				--print @Cmd				
				exec @RetCode=master..xp_cmdshell @Cmd	, no_output		
				if @RetCode<>0 return(14)

				set @Cmd='delete from '+@AcqDBNameEXT +'..historicaldata where [timestamp]<''' + convert(varchar,@UpperDateLimit1,120) + ''''
				exec (@Cmd)
				--delete from Twinacqtest..historicaldata where [timestamp]<@UpperDateLimit1
		--FlashAlarms		
				set @cmd=' exec ' + @AcqDBNameEXT +'.dbo.st_BuildView_Vw_FlashAlmsToSave '''+
							convert(varchar,@UpperDateLimit1,120) + ''','+ @CfgDBName 
				--print @cmd
				exec (@Cmd)
				set @Cmd='bcp "' + @AcqDBName + '..Vw_FlashAlmsToSave" out "'+
							@BackupDir + '\TempData.txt"  -c -q -t"|"  '
				exec @RetCode=master..xp_cmdshell @Cmd ,no_output
				if @RetCode<>0 return(13)

/*				if @DummyInt <10
					set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit1))+
							'0' + convert(char(1),@DummyInt)+'.txt'
				else
					set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit1))+
							 convert(char(2),@DummyInt)+'.txt' */
				set @cmd='dir "' + @BackupDir + '\' + @CurrentFAFile +'"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
 				if @RetCode=0
					set @Cmd='copy "'+@BackupDir + '\' + @CurrentFAFile + '" + "' +	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile + '" /B'
				ELSe				
					set @Cmd='move "'+	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile +'"'
				--print @Cmd				
				exec @RetCode=master..xp_cmdshell @Cmd	, no_output		
				if @RetCode<>0 return(14)

				set @Cmd='delete N from ' + @AcqDBNameEXT + '..FlashAlarms FA inner join ' +
							@AcqDBNameEXT + '..notifications N on
					FA.Id_FlashAlarm=N.Ref_IdFlashAlarm
					 where FA.[timestamp]<''' + convert(varchar,@UpperDateLimit1,120) + ''''
				exec (@Cmd)
				set @Cmd='delete from '+@AcqDBNameEXT +'..FlashAlarms where [timestamp]<''' + convert(varchar,@UpperDateLimit1,120) + ''''
				exec (@Cmd)

			END
		--Normale cancellazione di dati appartenenti ad un solo mese
			BEGIN
		--HistoricalData		
				set @cmd=' exec ' + @AcqDBNameEXT +'.dbo.st_BuildView_Vw_HDataToSave '''+
							convert(varchar,@UpperDateLimit,120)+ ''','+ @CfgDBName 
				--print @cmd
				exec (@Cmd)
				set @Cmd='bcp "' + @AcqDBName + '..Vw_HDataToSave" out "'+
							@BackupDir + '\TempData.txt"  -c -q -t"|"  '
--print @CMD
				exec @RetCode=master..xp_cmdshell @Cmd ,no_output
				if @RetCode<>0 return(13)

				set @DummyInt=month(@UpperDateLimit)
				if @DummyInt <10
					set @CurrentHDFile='HistData_'+ convert(char(4),year(@UpperDateLimit))+
							'0' + convert(char(1),@DummyInt)+'.txt'
				else
					set @CurrentHDFile='HistData_'+ convert(char(4),year(@UpperDateLimit))+
							 convert(char(2),@DummyInt)+'.txt'

				set @cmd='dir "' + @BackupDir + '\' + @CurrentHDFile +'"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
 				if @RetCode=0
					set @Cmd='copy "'+@BackupDir + '\' + @CurrentHDFile + '" + "' +	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentHDFile + '" /B'
				ELSe				
					set @Cmd='move "'+	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentHDFile +'"'
				--print @Cmd				
				exec @RetCode=master..xp_cmdshell @Cmd	, no_output		
				if @RetCode<>0 return(14)

				set @Cmd='delete from '+@AcqDBNameEXT +'..historicaldata where [timestamp]<''' + convert(varchar,@UpperDateLimit,120) + ''''
				exec (@Cmd)
				--delete from Twinacqtest..historicaldata where [timestamp]<@UpperDateLimit

		--FlashAlarms		
				set @cmd=' exec ' + @AcqDBNameEXT +'.dbo.st_BuildView_Vw_FlashAlmsToSave '''+
							convert(varchar,@UpperDateLimit,120) + ''','+ @CfgDBName 
				--print @cmd
				exec (@Cmd)
				set @Cmd='bcp "' + @AcqDBName + '..Vw_FlashAlmsToSave" out "'+
							@BackupDir + '\TempData.txt"  -c -q -t"|"  '
				exec @RetCode=master..xp_cmdshell @Cmd ,no_output
				if @RetCode<>0 return(13)

				if @DummyInt <10
					set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit))+
							'0' + convert(char(1),@DummyInt)+'.txt'
				else
					set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit))+
							 convert(char(2),@DummyInt)+'.txt'
				set @cmd='dir "' + @BackupDir + '\' + @CurrentFAFile +'"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
 				if @RetCode=0
					set @Cmd='copy "'+@BackupDir + '\' + @CurrentFAFile + '" + "' +	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile + '" /B'
				ELSe				
					set @Cmd='move "'+	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile +'"'
				--print @Cmd				
				exec @RetCode=master..xp_cmdshell @Cmd	, no_output		
				if @RetCode<>0 return(14)


				set @Cmd='delete N from ' + @AcqDBNameEXT + '..FlashAlarms FA inner join ' +
							@AcqDBNameEXT + '..notifications N on

					FA.Id_FlashAlarm=N.Ref_IdFlashAlarm
					 where FA.[timestamp]<''' + convert(varchar,@UpperDateLimit,120) + ''''
				exec (@Cmd)
				set @Cmd='delete from '+@AcqDBNameEXT +'..FlashAlarms where [timestamp]<''' + convert(varchar,@UpperDateLimit,120) + ''''
				exec (@Cmd)
/*
				delete N from Twinacqtest..FlashAlarms FA inner join Twinacqtest..notifications N on
					FA.Id_FlashAlarm=N.Ref_IdFlashAlarm
					 where FA.[timestamp]<@UpperDateLimit

				delete  from Twinacqtest..FlashAlarms 
					 where [timestamp]<@UpperDateLimit
*/

		END
	END

IF @RecoveryModel <> 'SIMPLE'
	BEGIN
		BACKUP LOG @AcqDBName TO DISK = @CurrentLogFileName	 WITH   DESCRIPTION = 'Automatic Televis Log',INIT
		BACKUP LOG @AcqDBName  WITH TRUNCATE_ONLY 
	END
DBCC SHRINKDATABASE (@AcqDBName ,25,  NOTRUNCATE)



RETURN(0)

GO

/****** Object:  Stored Procedure dbo.st_TWINCfgDBCheckSizeSaveData    Script Date: 27/02/2004 10.27.14 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_TWINCfgDBCheckSizeSaveData]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_TWINCfgDBCheckSizeSaveData]
GO


CREATE                 proc st_TWINCfgDBCheckSizeSaveData
 @CfgDBName varchar(128),
 @BackupDir varchar(256)
AS

/*
* PROCEDURE st_TWINCfgDBCheckSizeSaveData
* This StProc takes a series of actions which purpose is 
* to verify the size for Cfg Plant database and, if it is the case,
* to delete requested old data, Backup DBs and Truncate DB LOGs.
*
* Parameters:	@CfgDBName	Config plant DB Name
*				@BackupDir	backup directory
*				
*
* RETURN CODES:	0	No Error
*				10	BackupDir is null 
*				11	Unable to create BackupDir on disk
*
* NOTES: We retrieve DB Sizes constants from custom UDFs stored in MASTER Database
* The criteria to delete oldest data is to get the oldest week data stored, starting from
* oldest TIMESTAMP for ACQ DBs (same for Data and Alarms), from
* oldest TIMESTAMP for TWIN DB (just for Alarms, having no data), from
* oldest ValidateEndDate for CFG DBs (same for all Hist_* config tables)
*/


--declare @ACqDBNameEXT varchar(128)
declare @CfgDBNameEXT varchar(128) 
declare @OldestHDDate datetime
declare @OldestFADate datetime
declare @OldestDate datetime
declare @UpperDateLimit datetime
declare @UpperDateLimit1 datetime
declare @DBSizeLimit dec(10,2)
--declare @BackupDir varchar(256)
declare @CurrentHDFile varchar(256)
declare @CurrentFAFile varchar(256)
declare @CurrentBackupFileName varchar(256)
declare @CurrentLogFileName varchar(256)
declare @Cmd varchar(4000)
declare @RetCode int
declare @DBSize dec(10,2)
declare @DummyInt int
declare @RecoveryModel varchar(20)

--set @ACqDBName='TWINAcqTest'
--set @CfgDBName='TWINCfgTest'
set @CfgDBNameEXT=master.dbo.fc_GetRegularIdentifier(@CfgDBName)
set @DBSizeLimit=master.dbo.fc_DefaultCfgDBSize()
set @RecoveryModel=convert(varchar,DatabasePropertyEx(@CfgDBName,'Recovery'))

create table #DBSIZETABLE (
	dbsize dec)
set @cmd='use ' + @CfgDBNameEXT
set @cmd=@Cmd + ' insert #DBSIZETABLE exec sp_UsedSpace'
--print @cmd
exec (@Cmd)
select @Dbsize=dbsize from #DBSIZETABLE
drop table #DBSIZETABLE
--print 'DBSIZE:' + convert(varchar,@Dbsize)
/*
set @Cmd='select setvalue into T_GENSETS from ' +@CfgDBName +'..Genericsettings 
		where [Name]=''backupdir'''
exec (@Cmd)

select top 1 @BackupDir=Setvalue from T_GENSETS
drop table T_GENSETS


select @BackupDir=setvalue  from TwinCfgTest..Genericsettings
		where [Name]='backupdir'
*/

if @BackupDir is null 
	return(10)
else
	BEGIN
		set @Cmd='dir "' + @BackupDir +'"'
		exec @RetCode=master..xp_cmdshell @Cmd,  no_output
		if @retCode<>0
			BEGIN
				set @Cmd='md "' + @BackupDir +'"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
				if @RetCode<>0 return(11)
			END
	END
				
	BEGIN

	create table #TEMPDIR (Nomefile varchar(256) null)
	set @Cmd='dir "' + @BackupDir + '\'+ @CfgDBName + '_?.bck" /b/od'
	--print @cmd
	insert #TEMPDIR exec master..xp_cmdshell @Cmd
/*
	select top 1 @CurrentBackupFileName=nomefile from #TEMPDIR
	if @CurrentBackupFileName=null then
		set @CurrentBackupFileName=@ACqDBName + '_1.bck'
	else if @CurrentBackupFileName=@ACqDBName + '_1.bck'
		set @CurrentBackupFileName=@ACqDBName + '_2.bck'
	else


	select top 1 nomefile from #TEMPDIR*/
	select @DummyInt=count(*) from #TEMPDIR where nomefile like @CfgDBName+'%'
	IF @DummyInt=0
		set @CurrentBackupFileName=@CfgDBName + '_1.bck'
	else if @DummyInt=1
		set @CurrentBackupFileName=@CfgDBName + '_2.bck'
	else
		select top 1 @CurrentBackupFileName=nomefile from #TEMPDIR
	
	drop table #TEMPDIR
		--Backup DB
		set @CurrentBackupFileName=@BackupDir + '\'+ @CurrentBackupFileName
		set @CurrentLogFileName= left(@CurrentBackupFileName,len(@CurrentBackupFileName)-3) + 'log'
		if @RecoveryModel <> 'SIMPLE'
			BEGIN
				BACKUP LOG @CfgDBName TO DISK = @CurrentLogFileName	 WITH   DESCRIPTION = 'Automatic Televis Log',INIT
				BACKUP LOG @CfgDBName  WITH TRUNCATE_ONLY 
			END
		-- If DB size is OK, shrink and nothing else to do

		if @DBSize<@DBSizeLimit 
			BEGIN
				DBCC SHRINKDATABASE (@CfgDBName ,25,  NOTRUNCATE)
				return(0)
			END

		BACKUP DATABASE @CfgDBName TO DISK = @CurrentBackupFileName	 WITH   DESCRIPTION = 'Automatic Televis backup',INIT

		CREATE TABLE #T_DATES (EndDate datetime null)
		set @Cmd='insert #T_DATES select min(ValidateEndDate) from  ' +@CfgDBNameEXT +'..Hist_Networks' 
		exec (@Cmd)
		set @Cmd='insert #T_DATES select min(ValidateEndDate) from  ' +@CfgDBNameEXT +'..Hist_PhysInstruments' 
		exec (@Cmd)
		set @Cmd='insert #T_DATES select min(ValidateEndDate) from  ' +@CfgDBNameEXT +'..Hist_PhysResources' 
		exec (@Cmd)
		set @Cmd='insert #T_DATES select min(ValidateEndDate) from  ' +@CfgDBNameEXT +'..Hist_VirtualInstruments' 
		exec (@Cmd)
		set @Cmd='insert #T_DATES select min(ValidateEndDate) from  ' +@CfgDBNameEXT +'..Hist_VirtualResources' 
		exec (@Cmd)



		select  @OldestDate=Min(EndDate) from #T_DATES where enddate is not null
		drop table #T_DATES

		--Delete oldest week data
			BEGIN
		set @Upperdatelimit=dateadd(d,7,@oldestDate)
		set @Cmd='delete from '+@CfgDBNameEXT +'..Hist_VirtualResources where ValidateEndDate<''' + convert(varchar,@UpperDateLimit,120) + ''''
		exec (@Cmd)

		set @Cmd='delete from '+@CfgDBNameEXT +'..Hist_PhysResources where ValidateEndDate<''' + convert(varchar,@UpperDateLimit,120) + ''''
		exec (@Cmd)
		set @Cmd='delete from '+@CfgDBNameEXT +'..Hist_VirtualInstruments where ValidateEndDate<''' + convert(varchar,@UpperDateLimit,120) + ''''
		exec (@Cmd)
		set @Cmd='delete from '+@CfgDBNameEXT +'..Hist_PhysInstruments where ValidateEndDate<''' + convert(varchar,@UpperDateLimit,120) + ''''
		exec (@Cmd)
		set @Cmd='delete from '+@CfgDBNameEXT +'..Hist_Networks where ValidateEndDate<''' + convert(varchar,@UpperDateLimit,120) + ''''
		exec (@Cmd)

		END
	END

if @RecoveryModel <> 'SIMPLE'
	BEGIN
		BACKUP LOG @CfgDBName TO DISK = @CurrentLogFileName	 WITH   DESCRIPTION = 'Automatic Televis Log',INIT
		BACKUP LOG @CfgDBName  WITH TRUNCATE_ONLY 
	END

DBCC SHRINKDATABASE (@CfgDBName ,25,  NOTRUNCATE)


RETURN (0)

GO

/****** Object:  Stored Procedure dbo.st_TWINDBCheckSizeSaveData    Script Date: 27/02/2004 10.27.14 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_TWINDBCheckSizeSaveData]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_TWINDBCheckSizeSaveData]
GO


CREATE                  proc st_TWINDBCheckSizeSaveData
AS

/*
* PROCEDURE st_TWINDBCheckSizeSaveData
* This StProc is an 'all-in-one', taking a series of actions which purpose is 
* to verify the sizes for TWIN database and for ALL PLANTS registered databases and, if it is the case,
* to save requested old data to DISK, Backup DBs and Truncate DB LOGs.
*
* Parameters:	None
*				
*
* RETURN CODES:	0	No Error
*				>100.000: the leftmost two digits report generic or TWIN-related errors:
*								10	BackupDir not found in GenericSettings
*								11	Unable to create BackupDir on disk
*								12	Failed to build view to extract TWIN Alarms
*								13	Failed to Execute bcp shell
*								14	Failed to rename or append save data file on disk
*						 the mid two digits report the total numer of bad entries from the 'plants' table
*						 the rightmost two digits report the total numer of plants that fail to verify
*
* NOTES: We retrieve DB Sizes constants from custom UDFs stored in MASTER Database
* The criteria to delete oldest data is to get the oldest week data stored, starting from
* oldest TIMESTAMP for ACQ DBs (same for Data and Alarms), from
* oldest TIMESTAMP for TWIN DB (just for Alarms, having no data), from
* oldest ValidateEndDate for CFG DBs (same for all Hist_* config tables)
*/

declare @ACqDBName varchar(128)
declare @CfgDBName varchar(128) 
declare @ACqDBNameEXT varchar(128)
declare @CfgDBNameEXT varchar(128) 
declare @OldestHDDate datetime
declare @OldestFADate datetime
declare @OldestDate datetime
declare @UpperDateLimit datetime
declare @UpperDateLimit1 datetime
declare @DBSizeLimit dec(10,2)
declare @BackupDir varchar(256)
declare @CurrentHDFile varchar(256)
declare @CurrentFAFile varchar(256)
declare @CurrentBackupFileName varchar(256)
declare @CurrentLogFileName varchar(256)
declare @Cmd varchar(8000)
declare @RetCode int
declare @DBSize dec(10,2)
declare @DummyInt int
declare @DBFailedOPCount int
declare @DBFailedOP smallint
declare @PlantID int
declare @PlantName varchar(128)
declare @PlantBackupDir varchar(256)
declare @RecoveryModel varchar(20)

set @DBFailedOPCount=0
set @AcqDBName= db_name()
set @AcqDBNAmeEXT=master.dbo.fc_GetRegularIdentifier(@AcqDBName)
set @RecoveryModel=convert(varchar,DatabasePropertyEx(@AcqDBNAme,'Recovery'))
set @DBSizeLimit=master.dbo.fc_DefaultTwinDBSize()
create table #DBSIZETABLE (
	dbsize dec)

insert #DBSIZETABLE exec sp_UsedSpace
select @Dbsize=dbsize from #DBSIZETABLE
drop table #DBSIZETABLE


select @BackupDir=setvalue  from Genericsettings 
		where [Name]='backupdir'


if @BackupDir is null 
	return(100000)
else
	BEGIN
		set @Cmd='dir "' + @BackupDir + '"'
		exec @RetCode=master..xp_cmdshell @Cmd,  no_output
		if @retCode<>0
			BEGIN
				set @Cmd='md "' + @BackupDir + '"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
				if @RetCode<>0 return(110000)
			END
	END
				
	BEGIN

	create table #TEMPDIR (Nomefile varchar(256) null)
	set @Cmd='dir "' + @BackupDir + '\'+ @ACqDBName + '_?.bck" /b/od'
	--print @cmd
	insert #TEMPDIR exec master..xp_cmdshell @Cmd
/*
	select top 1 @CurrentBackupFileName=nomefile from #TEMPDIR
	if @CurrentBackupFileName=null then
		set @CurrentBackupFileName=@ACqDBName + '_1.bck'
	else if @CurrentBackupFileName=@ACqDBName + '_1.bck'
		set @CurrentBackupFileName=@ACqDBName + '_2.bck'
	else


	select top 1 nomefile from #TEMPDIR*/
	select @DummyInt=count(*) from #TEMPDIR where nomefile like @ACqDBName+'%'
	IF @DummyInt=0
		set @CurrentBackupFileName=@ACqDBName + '_1.bck'
	else if @DummyInt=1
		set @CurrentBackupFileName=@ACqDBName + '_2.bck'
	else
		select top 1 @CurrentBackupFileName=nomefile from #TEMPDIR
	
	drop table #TEMPDIR
		--Backup DB
		set @CurrentBackupFileName=@BackupDir + '\'+ @CurrentBackupFileName
		set @CurrentLogFileName= left(@CurrentBackupFileName,len(@CurrentBackupFileName)-3) + 'log'
		if @RecoveryModel <> 'SIMPLE'
			BEGIN
				BACKUP LOG @ACqDBNameEXT TO DISK = @CurrentLogFileName	 WITH   DESCRIPTION = 'Automatic Televis Log',INIT
				BACKUP LOG @ACqDBNameEXT  WITH TRUNCATE_ONLY 
			END
		-- If DB size is OK, shrink and nothing else to do

		if @DBSize<@DBSizeLimit 
			BEGIN
				DBCC SHRINKDATABASE (@ACqDBNameEXT ,25,  NOTRUNCATE)
				goto Verify_Plants
			END

		BACKUP DATABASE @ACqDBNameEXT TO DISK = @CurrentBackupFileName	 WITH   DESCRIPTION = 'Automatic Televis backup',INIT

		

		select @OldestDate = min(timestamp) from FlashAlarms

		set @Upperdatelimit=dateadd(d,7,@oldestDate)
		if datediff(m,@oldestDate,@Upperdatelimit)>0 --Finisce un mese e inizia quello seguente
			BEGIN
				SET @UpperDateLimit1=dateadd(d,-(day(@Upperdatelimit)-1),@Upperdatelimit)

		--FlashAlarms		
				exec @RetCode=st_BuildView_Vw_TwinFlashAlmsToSave	@UpperDateLimit1	
				if @RetCode<>0
					BEGIN
						set @DBFailedOPCount=120000
						goto Verify_Plants
					END	
				set @Cmd='bcp "' + @ACqDBNameEXT + '..Vw_TwinFlashAlmsToSave" out "'+
							@BackupDir + '\TempData.txt"  -c -q -t"|"  '
				exec @RetCode=master..xp_cmdshell @Cmd ,no_output
				if @RetCode<>0
					BEGIN
						set @DBFailedOPCount=130000
						goto Verify_Plants
					END	

				set @UpperDateLimit1=dateadd(d,-1,@UpperDateLimit1) --just to generate correct file name
				set @DummyInt=month(@UpperDateLimit1)
				if @DummyInt <10
					BEGIN
						set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit1))+
								'0' + convert(char(1),@DummyInt)+'.txt'
					END
				else
					BEGIN
						set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit1))+
								 convert(char(2),@DummyInt)+'.txt'
					END
				set @UpperDateLimit1=dateadd(d,1,@UpperDateLimit1)  --Correct date

				set @cmd='dir "' + @BackupDir + '\' + @CurrentFAFile +'"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
 				if @RetCode=0
					set @Cmd='copy "'+@BackupDir + '\' + @CurrentFAFile + '" + "' +	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile + '" /B'
				ELSe				
					set @Cmd='move "'+	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile + '"'
				--print @Cmd				
				exec @RetCode=master..xp_cmdshell @Cmd	, no_output		
				if @RetCode<>0
					BEGIN
						set @DBFailedOPCount=140000
						goto Verify_Plants
					END	


				delete N from FlashAlarms FA inner join notifications N on
					FA.Id_FlashAlarm=N.Ref_IdFlashAlarm and
					FA.Ref_PlantID=N.Ref_PlantID
					 where FA.[timestamp]<@UpperDateLimit1

				delete  from FlashAlarms 
					 where [timestamp]<@UpperDateLimit1 

	
		
			END
		--Normale cancellazione di dati appartenenti ad un solo mese
			BEGIN

		--FlashAlarms		
				exec @RetCode=st_BuildView_Vw_TwinFlashAlmsToSave	@UpperDateLimit		
				if @RetCode<>0
					BEGIN
						set @DBFailedOPCount=120000
						goto Verify_Plants
					END	
				set @Cmd='bcp "' + @ACqDBNameEXT + '..Vw_TwinFlashAlmsToSave" out "'+
							@BackupDir + '\TempData.txt"  -c -q -t"|"  '
				exec @RetCode=master..xp_cmdshell @Cmd ,no_output
				if @RetCode<>0
					BEGIN
						set @DBFailedOPCount=130000
						goto Verify_Plants
					END	

				set @DummyInt=month(@UpperDateLimit)
				if @DummyInt <10
					set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit))+
							'0' + convert(char(1),@DummyInt)+'.txt'
				else
					set @CurrentFAFile='FlashAlarms_'+ convert(char(4),year(@UpperDateLimit))+
							 convert(char(2),@DummyInt)+'.txt'
				set @cmd='dir "' + @BackupDir + '\' + @CurrentFAFile + '"'
				exec @RetCode=master..xp_cmdshell @Cmd,  no_output
 				if @RetCode=0
					set @Cmd='copy "'+@BackupDir + '\' + @CurrentFAFile + '" + "' +	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile + '" /B'
				ELSe				
					set @Cmd='move "'+	@BackupDir + '\TempData.txt" "' + @BackupDir + '\' + @CurrentFAFile + '"'
				--print @Cmd				
				exec @RetCode=master..xp_cmdshell @Cmd	, no_output		
				if @RetCode<>0
					BEGIN
						set @DBFailedOPCount=140000
						goto Verify_Plants
					END	
				
				delete N from FlashAlarms FA inner join notifications N on
					FA.Id_FlashAlarm=N.Ref_IdFlashAlarm and
					FA.Ref_PlantID=N.Ref_PlantID
					 where FA.[timestamp]<@UpperDateLimit

				delete  from FlashAlarms 
					 where [timestamp]<@UpperDateLimit 

		END
	END
if @RecoveryModel <> 'SIMPLE'
	BEGIN
		BACKUP LOG @ACqDBNameEXT TO DISK = @CurrentLogFileName	 WITH   DESCRIPTION = 'Automatic Televis Log',INIT
		BACKUP LOG @ACqDBNameEXT  WITH TRUNCATE_ONLY 
	END

DBCC SHRINKDATABASE (@ACqDBNameEXT ,25,  NOTRUNCATE)

Verify_Plants:

declare  crs_Plants cursor for
	select PlantID, [Name]  from plants

open crs_Plants
fetch next from crs_Plants into @PlantID,@PlantName

WHILE @@FETCH_STATUS = 0
	begin
		if @PlantName is null
			BEGIN 
				set @DBFailedOPCount=@DBFailedOPCount+100
			END
		ELSE
			BEGIN
				set @AcqDBName= @PlantName + 'AcqDB'
				set @CfgDBName= @PlantName + 'CfgDB'
				set @PlantBackupDir=@BackupDir + '\' + @PlantName
				IF exists (select name from master..sysdatabases where name=@AcqDBName) and
					exists (select name from master..sysdatabases where name=@CfgDBName)
					BEGIN
						set @DBFailedOP=0
						exec @RetCode=st_TWINAcqDBCheckSizeSaveData @AcqDBName, @CfgDBName, @PlantBackupDir
						set @DBFailedOP=@RetCode
						exec @RetCode=st_TWINCfgDBCheckSizeSaveData  @CfgDBName, @PlantBackupDir
						set @DBFailedOP=@DBFailedOP+@RetCode
						if @DBFailedOP>0
							set @DBFailedOPCount=@DBFailedOPCount+1
					END
				ELSE
					set @DBFailedOPCount=@DBFailedOPCount+100
			END
		fetch next from crs_Plants into @PlantID,@PlantName
	end
CLOSE crs_Plants
DEALLOCATE crs_Plants


return(@DBFailedOPCount)

GO


--------------------------- end procedure svecchiamento
------------------------------------------------------ 

--- Version Upgrade (user must only modify version number) 
--
UPDATE  GENERICSETTINGS SET SETVALUE='01.01.02' WHERE NAME='DB_VERSION'
GO


---------------------------------------------------------------------------------------
----------------------------- DB MASTER -----------------------------------------------
---------------------------------------------------------------------------------------


use master

-- Aggiornamento dei parametri del server: limitazione della memoria massima utilizzabile 
-- dal server = meemoria minima richiesta per l'istallazione

EXEC sp_configure 'show advanced option', '1'
RECONFIGURE
GO
EXEC sp_configure 'max server memory (MB)', '128'
RECONFIGURE

GO

-- modifiche stored procedure

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_DeleteTelevisDB]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_DeleteTelevisDB]
GO

CREATE PROCEDURE st_DeleteTelevisDB 

AS
declare @dbname as varchar(50)
declare @AcqDB as varchar(50)
declare @CfgDB as varchar(50)
declare @cmdAcq as varchar(200)
declare @cmdCfg as varchar(200)

set @AcqDB = 'AcqDB'
set @CfgDb = 'CfgDB'

declare CrsPlants cursor for select name  from TwinDB.dbo.plants
open CrsPlants
fetch next from CrsPlants into @dbname

while @@FETCH_STATUS = 0
 begin
  
  set @cmdCfg = 'DROP DATABASE [' + @dbname + @CfgDB + ']'
  set @cmdAcq = 'DROP DATABASE [' + @dbname + @AcqDB + ']'

  exec(@cmdCfg)
  exec(@cmdAcq)  

  fetch next from CrsPlants into @dbname
	  
 end

CLOSE CrsPlants
DEALLOCATE CrsPlants

DROP DATABASE TwinDB
DROP DATABASE _TemplateConfigDB_x
DROP DATABASE _TemplateAcquiredDB_x

GO

/****** Object:  Stored Procedure dbo.st_SetDefaultDBSize    Script Date: 27/02/2004 10.31.15 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[st_SetDefaultDBSize]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[st_SetDefaultDBSize]
GO

CREATE proc st_SetDefaultDBSize
@DBType varchar(4),
@DBSize dec(10,2)
AS
declare @cmd varchar (4000)
	SET QUOTED_IDENTIFIER ON 
	SET ANSI_NULLS ON 

	if @DBType='CFG'
		BEGIN
			if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fc_DefaultCfgDBSize]') and xtype in (N'FN', N'IF', N'TF'))
						
			drop function [dbo].[fc_DefaultCfgDBSize]
			set @cmd='
			CREATE   function dbo.fc_DefaultCfgDBSize() 
				returns dec(10,2)
			as
			BEGIN
				declare @Size dec(10,2)
				set @Size=' + convert(varchar,@DBSize) + '
				RETURN @Size
			END'
			exec (@Cmd)
			RETURN (0)
		END		
	ELSE IF @DBType='ACQ'
		BEGIN
			if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fc_DefaultAcqDBSize]') and xtype in (N'FN', N'IF', N'TF'))
						
			drop function [dbo].[fc_DefaultAcqDBSize]
			set @cmd='
			CREATE   function dbo.fc_DefaultAcqDBSize() 
				returns dec(10,2)
			as
			BEGIN
				declare @Size dec(10,2)
				set @Size=' + convert(varchar,@DBSize) + '
				RETURN @Size
			END'
			exec (@Cmd)
			RETURN (0)
		END		

	ELSE IF @DBType='TWIN'
		BEGIN
			if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fc_DefaultTWINDBSize]') and xtype in (N'FN', N'IF', N'TF'))
						
			drop function [dbo].[fc_DefaultTWINDBSize]
			set @cmd='
			CREATE   function dbo.fc_DefaultTWINDBSize() 
				returns dec(10,2)
			as
			BEGIN
				declare @Size dec(10,2)
				set @Size=' + convert(varchar,@DBSize) + '
				RETURN @Size
			END'
			exec (@Cmd)
			RETURN (0)
		END		
	
	ELSE
		RETURN (1)	


GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_usedspace]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_usedspace]
GO

CREATE          procedure sp_usedspace --- 1996/08/20 17:01 Rev. De Conti 23/02/2004

--@objname nvarchar(776) = null,		-- The object we want size on.
--@updateusage varchar(5) = false	,	-- Param. for specifying that
--@TotSpaceUsed dec(15,2) output					-- usage info. should be updated.
as
/*
* PROCEDURE sp_usedspace
* This StProc builds the view to save on disk data from HistoricalData table
* by the criteria 'TimeStamp < @Upperdate
*
* Parameters:	@UpperDate	reference date for rows to view
*				@CfgDBName	Config DB Name coupled to current Acquired Database
*
* RETURN CODES:	0	No Error
*				
*/
declare @TotSpaceUsed dec(15,2)
declare @updateusage varchar(5)
declare @objname nvarchar(776)
declare @id	int			-- The object id of @objname.
declare @type	character(2) -- The object type.
declare	@pages	int			-- Working variable for size calc.
declare @dbname sysname
declare @dbsize dec(15,0)
declare @logsize dec(15)
declare @bytesperpage	dec(15,0)
declare @pagesperMB		dec(15,0)
 
set @updateusage='true'
set @objname=null
/*Create temp tables before any DML to ensure dynamic
**  We need to create a temp table to do the calculation.
**  reserved: sum(reserved) where indid in (0, 1, 255)
**  data: sum(dpages) where indid < 2 + sum(used) where indid = 255 (text)
**  indexp: sum(used) where indid in (0, 1, 255) - data
**  unused: sum(reserved) - sum(used) where indid in (0, 1, 255)
*/
create table #spt_space
(
	rows		int null,
	reserved	dec(15) null,
	data		dec(15) null,
	indexp		dec(15) null,
	unused		dec(15) null
)

/*
**  Check to see if user wants usages updated.
*/

if @updateusage is not null
	begin
		select @updateusage=lower(@updateusage)

		if @updateusage not in ('true','false')
			begin
				raiserror(15143,-1,-1,@updateusage)
				return(1)
			end
	end
/*
**  Check to see that the objname is local.
*/
if @objname IS NOT NULL
begin

	select @dbname = parsename(@objname, 3)

	if @dbname is not null and @dbname <> db_name()
		begin
			raiserror(15250,-1,-1)
			return (1)
		end

	if @dbname is null
		select @dbname = db_name()

	/*
	**  Try to find the object.
	*/
	select @id = null
	select @id = id, @type = xtype
		from sysobjects
			where id = object_id(@objname)

	/*
	**  Does the object exist?
	*/
	if @id is null
		begin
			raiserror(15009,-1,-1,@objname,@dbname)
			return (1)
		end


	if not exists (select * from sysindexes
				where @id = id and indid < 2)

		if      @type in ('P ','D ','R ','TR','C ','RF') --data stored in sysprocedures
				begin
					raiserror(15234,-1,-1)
					return (1)
				end
		else if @type = 'V ' -- View => no physical data storage.
				begin
					raiserror(15235,-1,-1)
					return (1)
				end
		else if @type in ('PK','UQ') -- no physical data storage. --?!?! too many similar messages
				begin
					raiserror(15064,-1,-1)
					return (1)
				end
		else if @type = 'F ' -- FK => no physical data storage.
				begin
					raiserror(15275,-1,-1)
					return (1)
				end
end

/*
**  Update usages if user specified to do so.
*/

--if @updateusage = 'true'
	begin
		if @objname is null
			dbcc updateusage(0) with no_infomsgs
		else
			dbcc updateusage(0,@objname) with no_infomsgs
		print ' '
	end


set nocount on

/*
**  If @id is null, then we want summary data.
*/
/*	Space used calculated in the following way
**	@dbsize = Pages used
**	@bytesperpage = d.low (where d = master.dbo.spt_values) is
**	the # of bytes per page when d.type = 'E' and
**	d.number = 1.
**	Size = @dbsize * d.low / (1048576 (OR 1 MB))
*/
if @id is null
begin
	select @dbsize = sum(convert(dec(15),size))
		from dbo.sysfiles
		where (status & 64 = 0)

	select @logsize = sum(convert(dec(15),size))
		from dbo.sysfiles
		where (status & 64 <> 0)

	select @bytesperpage = low
		from master.dbo.spt_values
		where number = 1
			and type = 'E'
	select @pagesperMB = 1048576 / @bytesperpage
/*
	select  database_name = db_name(),
		database_size =
			ltrim(str((@dbsize + @logsize) / @pagesperMB,15,2) + ' MB'),
		'unallocated space' =
			ltrim(str((@dbsize -
				(select sum(convert(dec(15),reserved))
					from sysindexes
						where indid in (0, 1, 255)
				)) / @pagesperMB,15,2)+ ' MB')

	print ' '
*/

	/*
	**  Now calculate the summary data.
	**  reserved: sum(reserved) where indid in (0, 1, 255)
	*/
	insert into #spt_space (reserved)

		select sum(convert(dec(15),reserved))
			from sysindexes
				where indid in (0, 1, 255)

	/*
	** data: sum(dpages) where indid < 2
	**	+ sum(used) where indid = 255 (text)
	*/
	select @pages = sum(convert(dec(15),dpages))
			from sysindexes
				where indid < 2
	select @pages = @pages + isnull(sum(convert(dec(15),used)), 0)
		from sysindexes
			where indid = 255
	update #spt_space
		set data = @pages


	/* index: sum(used) where indid in (0, 1, 255) - data */
	update #spt_space
		set indexp = (select sum(convert(dec(15),used))
				from sysindexes
					where indid in (0, 1, 255))
			    - data

	/* unused: sum(reserved) - sum(used) where indid in (0, 1, 255) */
	update #spt_space
		set unused = reserved
				- (select sum(convert(dec(15),used))
					from sysindexes
						where indid in (0, 1, 255))

	select @TotSpaceUsed=reserved* d.low*1.10 / 1048576
		from #spt_space, master.dbo.spt_values d
		where d.number = 1
			and d.type = 'E'	
	set @TotSpaceUsed=@TotSpaceUsed
	select reserved* d.low*1.10 / 1048576 as TotSpaceUsed
		from #spt_space, master.dbo.spt_values d
		where d.number = 1
			and d.type = 'E'	

/*
	select reserved = ltrim(str(reserved * d.low / 1024.,15,0) +
				' ' + 'KB'),
		data = ltrim(str(data * d.low / 1024.,15,0) +
				' ' + 'KB'),
		index_size = ltrim(str(indexp * d.low / 1024.,15,0) +
				' ' + 'KB'),
		unused = ltrim(str(unused * d.low / 1024.,15,0) +
				' ' + 'KB')
		from #spt_space, master.dbo.spt_values d
		where d.number = 1
			and d.type = 'E'*/
end

/*
**  We want a particular object.
*/
else
begin
	/*
	**  Now calculate the summary data.
	**  reserved: sum(reserved) where indid in (0, 1, 255)
	*/
	insert into #spt_space (reserved)
		select sum(reserved)
			from sysindexes
				where indid in (0, 1, 255)
					and id = @id

	/*
	** data: sum(dpages) where indid < 2
	**	+ sum(used) where indid = 255 (text)
	*/
	select @pages = sum(dpages)
			from sysindexes
				where indid < 2
					and id = @id
	select @pages = @pages + isnull(sum(used), 0)
		from sysindexes
			where indid = 255
				and id = @id
	update #spt_space
		set data = @pages


	/* index: sum(used) where indid in (0, 1, 255) - data */
	update #spt_space
		set indexp = (select sum(used)
				from sysindexes
					where indid in (0, 1, 255)
						and id = @id)
			    - data

	/* unused: sum(reserved) - sum(used) where indid in (0, 1, 255) */
	update #spt_space
		set unused = reserved
				- (select sum(used)
					from sysindexes
						where indid in (0, 1, 255)
							and id = @id)
	update #spt_space
		set rows = i.rows
			from sysindexes i
				where i.indid < 2
					and i.id = @id

	select name = object_name(@id),
		rows = convert(char(11), rows),
		reserved = ltrim(str(reserved * d.low / 1024.,15,0) +
				' ' + 'KB'),
		data = ltrim(str(data * d.low / 1024.,15,0) +
				' ' + 'KB'),
		index_size = ltrim(str(indexp * d.low / 1024.,15,0) +
				' ' + 'KB'),
		unused = ltrim(str(unused * d.low / 1024.,15,0) +
				' ' + 'KB')
	from #spt_space, master.dbo.spt_values d
		where d.number = 1
			and d.type = 'E'
end

return (0) -- sp_spaceused


GO

/****** Object:  User Defined Function dbo.fc_GetRegularIdentifier    Script Date: 27/02/2004 10.30.36 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fc_GetRegularIdentifier]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fc_GetRegularIdentifier]
GO

CREATE function fc_GetRegularIdentifier(@InputID varchar(128))
returns varchar(128)
as
	BEGIN

		declare @TempID varchar(128)
		if  substring(@InputID,1,1)  not like ('[a-zA-Z_@#]')
			set @TempID= '[' + @InputID + ']'
		else if patindex('% %',@InputID)> 0
			set @TempID= '[' + @InputID + ']'
		else
			set @TempID=  @InputID 
	
		RETURN (@TempID)
	END


GO

/****** Object:  User Defined Function dbo.fc_DefaultTWINDBSize    Script Date: 27/02/2004 10.30.36 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fc_DefaultTWINDBSize]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fc_DefaultTWINDBSize]
GO


			CREATE   function dbo.fc_DefaultTWINDBSize() 
				returns dec(10,2)
			as
			BEGIN
				declare @Size dec(10,2)
				set @Size=1700.0
				RETURN @Size
			END
GO

/****** Object:  User Defined Function dbo.fc_DefaultCfgDBSize    Script Date: 27/02/2004 10.30.36 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fc_DefaultCfgDBSize]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fc_DefaultCfgDBSize]
GO


			CREATE   function dbo.fc_DefaultCfgDBSize() 
				returns dec(10,2)
			as
			BEGIN
				declare @Size dec(10,2)
				set @Size=1500.0
				RETURN @Size
			END
GO

/****** Object:  User Defined Function dbo.fc_DefaultAcqDBSize    Script Date: 27/02/2004 10.30.36 ******/
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fc_DefaultAcqDBSize]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fc_DefaultAcqDBSize]
GO


			CREATE   function fc_DefaultAcqDBSize() 
				returns dec(10,2)
			as
			BEGIN
				declare @Size dec(10,2)
				set @Size=1700.0
				RETURN @Size
			END


GO

-- Script generated on 26/02/2004 11.04
-- By: F. De Conti
-- Job to manage Televis TWIN databases sizes

BEGIN TRANSACTION            
  DECLARE @JobID BINARY(16)  
  DECLARE @ReturnCode INT    
  SELECT @ReturnCode = 0     
IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
  EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'

  -- Delete the job with the same name (if it exists)
  SELECT @JobID = job_id     
  FROM   msdb.dbo.sysjobs    
  WHERE (name = N'TWIN_DBChekSizeVerifyData')       
  IF (@JobID IS NOT NULL)    
  BEGIN  
  -- Check if the job is a multi-server job  
  IF (EXISTS (SELECT  * 
              FROM    msdb.dbo.sysjobservers 
              WHERE   (job_id = @JobID) AND (server_id <> 0))) 
  BEGIN 
    -- There is, so abort the script 
    RAISERROR (N'Unable to import job ''TWIN_DBChekSizeVerifyData'' since there is already a multi-server job with this name.', 16, 1) 
    GOTO QuitWithRollback  
  END 
  ELSE 
    -- Delete the [local] job 
    EXECUTE msdb.dbo.sp_delete_job @job_name = N'TWIN_DBChekSizeVerifyData' 
    SELECT @JobID = NULL
  END 

BEGIN 

  -- Add the job
  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'TWIN_DBChekSizeVerifyData', @owner_login_name = N'sa', @description = N'Job to contain Televis DBs size and save old data to disk', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 3, @delete_level= 0
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job steps
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'TwinJobStep_1', @command = N'exec st_TWINDBCheckSizeSaveData', @database_name = N'TwinDB', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 

  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the job schedules
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'TWIN_Default_Sched', @enabled = 1, @freq_type = 4, @active_start_date = 20040226, @active_start_time = 0, @freq_interval = 1, @freq_subday_type = 1, @freq_subday_interval = 0, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

  -- Add the Target Servers
  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 

END
COMMIT TRANSACTION          
GOTO   EndSave              
QuitWithRollback:
  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
EndSave: 


GO



----------------------- Aggiornamento dei dati e stored procedure    -------------------------------
----------------------- nei DB Acuired/ Config  dei plant registrati -------------------------------
----------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------
-- Il Ciclo sui plants DB viene eseguito partendo dal TWIN DB , SOLO dopo
-- l'inserimento delle funzioni sul DB Master ed in particolere della
-- funzione fc_GetRegularIdentifier che viene qui referenziata
---------------------------------------------------------------------------

USE TwinDB

declare @dbname as varchar(50)
declare @AcqDB as varchar(50)
declare @CfgDB as varchar(50)
declare @dbnameEx as varchar(128)
declare @dbnameCfgEx as varchar(128)
set @AcqDB = 'AcqDB'
set @CfgDB = 'CfgDB'

declare @cmd as varchar(4000)

CREATE TABLE MY_COMANDTEXT (command varchar(4000))

declare CrsPlants cursor for select name from TwinDB.dbo.plants
open CrsPlants
fetch next from CrsPlants into @dbname

while @@FETCH_STATUS = 0
 begin 


-------------------------- Aggiornamento Plants CFG  ---------------------------------------
--
set @dbnameCfgEx = master.dbo.fc_GetRegularIdentifier(@dbname + @CfgDB)

set @cmd = 'USE ' + @dbnameCfgEx  + '
SET IDENTITY_INSERT Instrumentsdictionary ON

delete from Instrumentsdictionary where ID_DictInstrument = 219
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (219,176,1025,''INVENSYS DIGIFROST ADVANCED SERIES'',''ID 985LX HOT GAS'',''HOT GAS'')

delete from Instrumentsdictionary where ID_DictInstrument = 231
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (231,142,1025,''FAN COIL'',''FC BASICOM'',''FAN COIL'')

delete from Instrumentsdictionary where ID_DictInstrument = 233
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (233,207,1025,''ET 950 LX'',''ET 950 LX'',''ET 950 LX'')

delete from Instrumentsdictionary where ID_DictInstrument = 234
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (234,141,1027,''IC 917 LX'',''IC 917 LX'',''IC 917 LX'')

delete from Instrumentsdictionary where ID_DictInstrument = 235
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (235,166,1027,''IC 917 LX'',''IC 917 LX'',''IC 917 LX'')

delete from Instrumentsdictionary where ID_DictInstrument = 236
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (236,167,2055,''INVENSYS WIDE'',''IWP 760'',''IWK 4 Keys Rivacold'')

delete from Instrumentsdictionary where ID_DictInstrument = 239
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (239,188,1025,''ID 985LX HACCP'',''ID 985LX HACCP ANNUAL CALENDAR'',''ID 985LX HACCP ANNUAL CALENDAR'')

delete from Instrumentsdictionary where  ID_DictInstrument= 240
insert into Instrumentsdictionary (ID_DictInstrument,MicroFamily,ModelCode,FamilyName,ModelName,Description) values (240,175,2050,''ID 961 KIFATO'',''ID 961 KIFATO'',''ID 961 KIFATO'')

SET IDENTITY_INSERT  InstrumentsDictionary OFF 

delete from StatesDictionary where statecode=832
insert into StatesDictionary (StateCode,CountryCode,Description) values (832, 0, ''Timer loop'')
insert into StatesDictionary (StateCode,CountryCode,Description) values (832, 34, ''Ciclo timer'')
insert into StatesDictionary (StateCode,CountryCode,Description) values (832, 39, ''Ciclo timer'')
insert into StatesDictionary (StateCode,CountryCode,Description) values (832, 44, ''Timer loop'')
'

exec (@cmd)

set @cmd = 'USE ' + @dbnameCfgEx  + '

delete from CompactVsTelevisAlm where FW_Mask = 74 and CompactAlmCode IN (82,84,85,86)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (74,82,1611)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (74,84,1203)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (74,85,1003)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (74,86,1103)

delete from CompactVsTelevisAlm where FW_Mask = 166
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (166,50,1613)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (166,76,1637) 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (166,79,1621)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (166,87,1000) 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (166,88,1100)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (166,89,1000)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (166,90,1100)

delete from CompactVsTelevisAlm where FW_Mask = 175
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,53,1200)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,54,1201)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,56,1000)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,57,1100)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,76,1637) 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,78,1609)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,79,1621)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (175,80,1608) 


delete from CompactVsTelevisAlm where FW_Mask = 190
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (190,53,1200)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (190,54,1201)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (190,56,1000)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (190,57,1100)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (190,76,1637) 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (190,79,1621)
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (190,80,1608) 
	 
'
  exec (@cmd)



-------------------------- Aggiornamento Palnts ACQ ---------------------------------------
--
  set @dbnameEx = master.dbo.fc_GetRegularIdentifier(@dbname + @AcqDB)

  set @cmd = 'USE ' + @dbnameEx  + '
	if exists (select * from dbo.sysobjects where id = object_id(N''[dbo].[st_BuildView_Vw_FlashAlmsToSave]'') and OBJECTPROPERTY(id, N''IsProcedure'') = 1)
	drop procedure [dbo].[st_BuildView_Vw_FlashAlmsToSave] 
        '
  exec (@cmd)


-- creazione della Stored Procedure : viene salvato testo in una tabella 
-- e poi riletto da un altro batch che prima di eseguirla antepone lo switch del DB (USE..).
-- Infatti tale comando deve essere il primo comando di un batch 
  set @cmd = ''
  set @cmd ='CREATE   proc [st_BuildView_Vw_FlashAlmsToSave]
	@UpperDate datetime,
	@CfgDBName varchar(128)
	as
	declare @CfgDBNameEXT varchar(128)
	declare @MyCmd varchar(4000)
	if exists (select * from dbo.sysobjects where id = object_id(N''[dbo].[Vw_FlashAlmsToSave]'') and OBJECTPROPERTY(id, N''IsView'') = 1)
	drop view [dbo].[Vw_FlashAlmsToSave]
	
	set @CfgDBNameEXT=master.dbo.fc_GetRegularIdentifier(@CfgDBName)
	set @MyCmd=''create view [dbo].[Vw_FlashAlmsToSave]
	AS
	SELECT  top 100 percent 
			convert(varchar,FA.[Timestamp],120) as AlmTimeStamp, FA.Ref_VirtInstrumentID,  VI.[Name] AS InstrName,FA.AlarmCode, 
			FA.AlarmState, convert(decimal(15,2),FA.AlarmValue) as AlmValue, 
			FA.ExecStatus 
	FROM    dbo.FlashAlarms FA inner join '' + @CfgDBNameEXT + ''.dbo.VirtualInstruments VI ON
			 FA.Ref_VirtInstrumentID = VI.ID_VirtualInstrument and
			FA.[timestamp]>= VI.validatestartdate
	where FA.[timestamp]<'''''' + convert(varchar,@upperdate,101) + ''''''
	order by AlmTimeStamp
	UNION
	SELECT  top 100 percent 
			convert(varchar,FA.[Timestamp],120) as AlmTimeStamp, FA.Ref_VirtInstrumentID,  VI.[Name] AS InstrName,FA.AlarmCode, 
			FA.AlarmState, convert(decimal(15,2),FA.AlarmValue) as AlmValue, 
			FA.ExecStatus 
	FROM    dbo.FlashAlarms FA inner join '' + @CfgDBNameEXT + ''.dbo.Hist_VirtualInstruments VI ON
			 FA.Ref_VirtInstrumentID = VI.ID_VirtualInstrument and
			FA.[timestamp]between VI.validatestartdate and VI.validateenddate
	where FA.[timestamp]<'''''' + convert(varchar,@upperdate,101) + ''''''
	order by AlmTimeStamp''
	exec (@MyCmd)
	
	RETURN (0)
'
  DELETE FROM MY_COMANDTEXT
  Insert into MY_COMANDTEXT values ( @cmd)

  set @cmd = 'USE ' + @dbnameEx + '
	declare @cmdtmp as varchar (4000)
        select @cmdtmp=command from Twindb.dbo.MY_COMANDTEXT 
	exec(@cmdtmp) '
 
  exec (@cmd)

  set @cmd = 'USE ' + @dbnameEx + '
	if exists (select * from dbo.sysobjects where id = object_id(N''[dbo].[st_BuildView_Vw_HDataToSave]'') and OBJECTPROPERTY(id, N''IsProcedure'') = 1)
	drop procedure [dbo].[st_BuildView_Vw_HDataToSave]
'
  exec (@cmd)
  set @cmd = ''

-- creazione della Stored Procedure : viene salvato testo in una tabella 
-- e poi riletto da un altro batch che prima di eseguirla antepone lo switch del DB (USE..).
-- Infatti tale comando deve essere il primo comando di un batch 
  set @cmd = '
        CREATE            proc [st_BuildView_Vw_HDataToSave]
	@UpperDate datetime,
	@CfgDBName varchar(128)
	as
	
	declare @CfgDBNameEXT varchar(128)
	declare @MyCmd varchar(4000)
	if exists (select * from dbo.sysobjects where id = object_id(N''[dbo].[Vw_HDataToSave]'') and OBJECTPROPERTY(id, N''IsView'') = 1)
	drop view [dbo].[Vw_HDataToSave]
	
	set @CfgDBNameEXT=master.dbo.fc_GetRegularIdentifier(@CfgDBName)
	set @MyCmd=''create view [dbo].[Vw_HDataToSave]
	AS
	SELECT  top 100 percent  convert(varchar,HD.[Timestamp],120) as RecTimeStamp,HD.LogResID,VR.Name AS ResName,VI.ID_VirtualInstrument, VI.Name AS InstrName ,
			convert(decimal(15,2),HD.[Value]) as RecValue 
	FROM  dbo.HistoricalData HD inner join (
		  	'' + @CfgDBNameEXT + ''.dbo.VirtualResources VR INNER JOIN
	        '' + @CfgDBNameEXT + ''.dbo.VirtualInstruments VI ON VR.Ref_IDVirtualInstr = VI.ID_VirtualInstrument)
			ON HD.LogResID=VR.ID_VirtualResource and hd.[timestamp]>= vr.validatestartdate
	where [timestamp]<'''''' + convert(varchar,@upperdate,101) + ''''''
	order by rectimestamp
	UNION
	SELECT  top 100 percent  convert(varchar,HD.[Timestamp],120) as RecTimeStamp,HD.LogResID,VR.Name AS ResName,VI.ID_VirtualInstrument, VI.Name AS InstrName ,
			convert(decimal(15,2),HD.[Value]) as RecValue 
	FROM  dbo.HistoricalData HD inner join (
		  	'' + @CfgDBNameEXT + ''.dbo.Hist_VirtualResources VR INNER JOIN
	        '' + @CfgDBNameEXT + ''.dbo.Hist_VirtualInstruments VI ON 
			VR.Ref_IDVirtualInstr = VI.ID_VirtualInstrument and
			VR.ValidateStartDate>=VI.ValidateStartDate and
			VR.ValidateEndDate<=VI.ValidateEndDate )
			ON HD.LogResID=VR.ID_VirtualResource and 
				hd.[timestamp]between vr.validatestartdate and vr.validateenddate
	where [timestamp]<'''''' + convert(varchar,@upperdate,101) + ''''''
	order by rectimestamp''
	
	exec (@MyCmd)
	
	RETURN (0)
'
  DELETE FROM MY_COMANDTEXT 
  Insert into MY_COMANDTEXT  values ( @cmd)

  set @cmd = 'USE ' + @dbnameEx + '
	declare @cmdtmp as varchar (4000)
        select @cmdtmp=command from Twindb.dbo.MY_COMANDTEXT 
	exec(@cmdtmp) '

  exec (@cmd)

  
  fetch next from CrsPlants into @dbname
	  
 end

CLOSE CrsPlants
DEALLOCATE CrsPlants

DROP TABLE MY_COMANDTEXT 


----------------------- END Aggiornamento delle stored procedure nei DB Acuired dei plant registrati
-----------------------------------------------------------------------------------------------------

GO

