/**************************/
/* Televis Manage Dbs     */
/**************************/

print ' '
print 'Procedura Controllo DBs Televis'
print ' '
GO

SELECT GETDATE()
GO
use master
go

print ' '
print 'Situazione iniziale LOGS' 
print ' '
GO
dbcc sqlperf(logspace)
GO

print ' '
print 'CHECK MASTER'
print ' '
go
use master
go
dbcc checkdb
go
SELECT GETDATE()
GO

/**********************/
/*    _AcquiredDB_x   */
/**********************/


print ' '                                                                   
print 'CHECK tabelle _AcquiredDB_x' 
print ' '                                                                   
go                                                                         
use _AcquiredDB_x                                                                
go                     
dbcc checktable(historicaldata)
dbcc checktable(FlashAlarms)
dbcc checktable(TemporaryData)  
go                                                           
SELECT GETDATE()
GO

print ''
print 'UpdateStatistics di tutte le tabelle per _AcquiredDB_x'
print ''
GO                                                                         
use _AcquiredDB_x                                                                
go  
update statistics EventsContext with NORECOMPUTE  
go
update statistics EventsContext_Sync with NORECOMPUTE  
go
update statistics EventsDictionary with NORECOMPUTE  
go
update statistics FlashAlarms with NORECOMPUTE  
go
update statistics FlashAlarmsNotes with NORECOMPUTE  
go
update statistics FlashEvents with NORECOMPUTE  
go
update statistics FlashLog with NORECOMPUTE  
go
update statistics HistoricalData with NORECOMPUTE  
go
update statistics HistoricalData_Sync with NORECOMPUTE  
go
update statistics IntervalSets with NORECOMPUTE  
go
update statistics LoggableEvents with NORECOMPUTE  
go
update statistics LogicalDestinations with NORECOMPUTE  
go
update statistics Notifications with NORECOMPUTE  
go
update statistics PhysDestinations with NORECOMPUTE  
go
update statistics Rel_ISetPhysDest with NORECOMPUTE  
go
update statistics Rel_IsetAlarmClass with NORECOMPUTE  
go
update statistics RouterTypes with NORECOMPUTE  
go
update statistics RoutingSim with NORECOMPUTE  
go
update statistics TemporaryData with NORECOMPUTE  
go
update statistics TemporaryData_Sync with NORECOMPUTE  
go
update statistics TimeIntervals with NORECOMPUTE  
go
update statistics TimeIntervalsAlarmCls with NORECOMPUTE  
go
update statistics TimeIntervalsPhDest with NORECOMPUTE  
go
update statistics ActionCodes with NORECOMPUTE  
go
update statistics AlarmClassActionDetailInfo with NORECOMPUTE  
go
update statistics AlarmClasses with NORECOMPUTE  
go
update statistics AlarmClassesConnection with NORECOMPUTE  
go
update statistics AlarmClassesDictionary with NORECOMPUTE  
go
update statistics AlarmsContext with NORECOMPUTE  
go
update statistics AlarmsContext_Sync with NORECOMPUTE  
go
update statistics AlarmsDictionary with NORECOMPUTE  
go
update statistics DeviceStatus with NORECOMPUTE  
go
update statistics EventsActions with NORECOMPUTE  
go
SELECT GETDATE()
GO

print ' '
print 'TRUNCATE DEI LOG _AcquiredDb_X' 
print ' '
go
BACKUP LOG [_AcquiredDb_X] with truncate_only
go
SELECT GETDATE()
GO

print ' '
print 'SHRINK DATABASE _AcquiredDb_X' 
print ' '
go
DBCC SHRINKDATABASE (_AcquiredDb_X, 10)
go
SELECT GETDATE()
GO

/*******************/
/*    ConfigDB_x   */
/*******************/

print ' '                                                                   
print 'CHECK tabelle _ConfigDB_x' 
print ' '                                                                   
go                                                                         
use _ConfigDB_x                                                                
go                     
dbcc checktable(GenericSettings)
dbcc checktable(Networks)
dbcc checktable(PhysInstruments)  
dbcc checktable(PhysResources)
dbcc checktable(VirtualInstruments)  
dbcc checktable(VirtualPhysResourceTable)  
dbcc checktable(VirtualResources)  
dbcc checktable(Hist_Networks)  
dbcc checktable(Hist_PhysInstruments)
dbcc checktable(Hist_PhysResources)  
dbcc checktable(Hist_VirtualInstruments)  
dbcc checktable(Hist_VirtualResources)  
go                                                           
SELECT GETDATE()
GO


print ''
print 'UpdateStatistics di tutte le tabelle per _ConfigDB_X'
print ''
GO
use _ConfigDB_X
update statistics GenericSettings with NORECOMPUTE  
go
update statistics IncomingCall with NORECOMPUTE  
go
update statistics Languages with NORECOMPUTE  
go
update statistics GroupModelLanguages with NORECOMPUTE  
go
update statistics ParameterModelLanguages with NORECOMPUTE  
go
update statistics Plants with NORECOMPUTE  
go
update statistics LayoutList with NORECOMPUTE  
go
update statistics LayoutObjectResources with NORECOMPUTE  
go
update statistics LayoutObjects with NORECOMPUTE  
go
update statistics CategoriesDictionary with NORECOMPUTE  
go
update statistics Chain_Databases with NORECOMPUTE  
go
update statistics Chain_Databases_Hist with NORECOMPUTE  
go
update statistics CommandsList with NORECOMPUTE  
go
update statistics ConfigCounters with NORECOMPUTE  
go
update statistics ContextRelations with NORECOMPUTE  
go
update statistics Controls with NORECOMPUTE  
go
update statistics CtlPropDataTypes with NORECOMPUTE  
go
update statistics CtlPropGroups with NORECOMPUTE  
go
update statistics CtlPropValues with NORECOMPUTE  
go
update statistics CtlProps with NORECOMPUTE  
go
update statistics GUI_ChoiceSets with NORECOMPUTE  
go
update statistics GUI_ChoicesStrings with NORECOMPUTE  
go
update statistics GUI_Images with NORECOMPUTE  
go
update statistics GUI_Strings with NORECOMPUTE  
go
update statistics Groups with NORECOMPUTE  
go
update statistics GroupsPermissionsCollection with NORECOMPUTE  
go
update statistics Hist_Networks with NORECOMPUTE  
go
update statistics Hist_PhysInstruments with NORECOMPUTE  
go
update statistics Hist_PhysResources with NORECOMPUTE  
go
update statistics Hist_VirtualInstruments with NORECOMPUTE  
go
update statistics Hist_VirtualResources with NORECOMPUTE  
go
update statistics InstrumentsDictionary with NORECOMPUTE  
go
update statistics ModulesStrings with NORECOMPUTE  
go
update statistics Networks with NORECOMPUTE  
go
update statistics OperationsObjectsDictionary with NORECOMPUTE  
go
update statistics PhysInstruments with NORECOMPUTE  
go
update statistics PhysResources with NORECOMPUTE  
go
update statistics PriorityLevels with NORECOMPUTE  
go
update statistics ResourceDataTypeLanguages with NORECOMPUTE  
go
update statistics ResourceDataTypeTable with NORECOMPUTE  
go
update statistics ResourceTypeLanguages with NORECOMPUTE  
go
update statistics ResourceTypeList with NORECOMPUTE  
go
update statistics SchedulableCommands with NORECOMPUTE  
go
update statistics Scopes with NORECOMPUTE  
go
update statistics ScreenResolutions with NORECOMPUTE  
go
update statistics StatesDictionary with NORECOMPUTE  
go
update statistics Tasks with NORECOMPUTE  
go
update statistics TasksList with NORECOMPUTE  
go
update statistics Users with NORECOMPUTE  
go
update statistics UsersSpecPermissionsCollection with NORECOMPUTE  
go
update statistics VirtualConfHist with NORECOMPUTE  
go
update statistics VirtualInstrumentCategories with NORECOMPUTE  
go
update statistics VirtualInstrumentCategoryTable with NORECOMPUTE  
go
update statistics VirtualInstrumentClasses with NORECOMPUTE  
go
update statistics VirtualInstrumentClassesLanguages with NORECOMPUTE  
go
update statistics VirtualInstruments with NORECOMPUTE  
go
update statistics VirtualPhysResourceTable with NORECOMPUTE  
go
update statistics VirtualResources with NORECOMPUTE  
go
update statistics LoggingData with NORECOMPUTE  
go
update statistics LoggingContextActions with NORECOMPUTE  
go
update statistics LoggingContext with NORECOMPUTE  
go
update statistics LayoutImages with NORECOMPUTE  
go
update statistics GraphAxes with NORECOMPUTE  
go
update statistics GraphCfg with NORECOMPUTE  
go
update statistics GraphResources with NORECOMPUTE  
go
update statistics AutomaticReport with NORECOMPUTE  
go
update statistics AutomatiReportVar with NORECOMPUTE  
go
update statistics PrinterSettings with NORECOMPUTE  
go
update statistics InstrTypexDigitalOutput with NORECOMPUTE  
go
SELECT GETDATE()
GO


print ' '
print 'TRUNCATE DEI LOG _ConfigDb_X' 
print ' '
go
BACKUP LOG [_ConfigDb_X] with truncate_only
go
SELECT GETDATE()
GO


print ' '
print 'SHRINK DATABASE _ConfigDb_X' 
print ' '
go
DBCC SHRINKDATABASE (_ConfigDb_X, 10)
go
SELECT GETDATE()
GO


print ' '
print 'Situazione Finale LOGS' 
print ' '
GO
dbcc sqlperf(logspace)
GO
SELECT GETDATE()
GO