-------------------------------------------------------------------------------------
------------ Step 1: Before Net Scan : SEE at SupportForDriverChange_1_2_0.txt ------
-------------------------------------------------------------------------------------

USE _ConfigDB_x

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VirtualInstruments_Tmp]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[VirtualInstruments_Tmp]
GO 

CREATE TABLE [VirtualInstruments_Tmp] (
	[ID_VirtualInstrument] [int] NOT NULL ,
	[Name] [varchar] (50) NULL ,
	[Description] [varchar] (50) NULL ,
	[ValidateStartDate] [datetime] NULL ,
	[LastModifiedDate] [datetime] NULL ,
	[StandbyFlag] [smallint] NULL ,
	[Notes] [varchar] (255) NULL ,
	[RegSpeedHist] [smallint] NULL ,
	[RegSpeedFlash] [smallint] NULL ,
	[InstrumentClassCode] [int] NOT NULL ,
	[InternalUpdate] [smallint] NULL ,
	[rowguid]  uniqueidentifier ROWGUIDCOL  NULL
) ON [PRIMARY]
GO


insert into virtualinstruments_Tmp select * from virtualinstruments

GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[PhysInstruments_Tmp]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[PhysInstruments_Tmp]
GO

CREATE TABLE [dbo].[PhysInstruments_Tmp] (
	[ID_PhysInstrument] [int] NOT NULL ,
	[NetworkAddress] [varchar] (9) ,
	[NetworkSubAddress] [varchar] (10) ,
	[Description] [varchar] (50) ,
	[ValidateStartDate] [datetime] NULL ,
	[LastModifiedDate] [datetime] NULL ,
	[StandbyFlag] [smallint] NOT NULL ,
	[FirmwareRelease] [smallint] NULL ,
	[Ref_IDDictInstr] [int] NOT NULL ,
	[Ref_IDNet] [int] NOT NULL ,
	[InternalUpdate] [smallint] NULL ,
	[rowguid]  uniqueidentifier ROWGUIDCOL  NULL 
) ON [PRIMARY]
GO

insert into PhysInstruments_Tmp select * from PhysInstruments

GO


