------------------------------------------------------------------
------------------------------------------------------------------
-- Author:
-- Date:
-- Notes: Script non compatible with OLEDB if GO is present to
--        separate batch. GO must be placed  before CREATE statements.
--
--
------------------------------------------------------------------
------------------------------------------------------------------

-- place customom SQL And DDL for upgrade here (place GO before CREATE statements) 

----------------------------------------------------------------------------------------
-------------------------------------------CONFIG DB -----------------------------------
----------------------------------------------------------------------------------------
USE _ConfigDB_x


-- insert of new instruments

SET IDENTITY_INSERT Instrumentsdictionary ON

delete from Instrumentsdictionary where ID_DictInstrument between 269 and 270
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(269,221,1025,'INVENSYS WIDE SUPERMARKET','IWP 750 SM','IWP 750 SM')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(270,221,1026,'INVENSYS WIDE SUPERMARKET','IWP 760 SM','IWP 760 SM')

SET IDENTITY_INSERT  InstrumentsDictionary OFF 

-- insert of new states

delete from StatesDictionary where statecode = 841
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,0,'Frame Heater')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,34,'Frame Heater')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,39,'Resistenze antiappannanti')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,44,'Frame Heater')
GO

----------------------------------------------------------------------------------------------


--- Version Upgrade (user must only modify version number) 
--
USE _ConfigDB_x
UPDATE  GENERICSETTINGS SET SETVALUE='01.03.01' WHERE NAME='DB_VERSION'
GO
