------------------------------------------------------------------
------------------------------------------------------------------
-- Author:
-- Date:
-- Notes: Script non compatible with OLEDB if GO is present to
--        separate batch. GO must be placed  before CREATE statements.
--
--
------------------------------------------------------------------
------------------------------------------------------------------


------------------------------------------------------------------
---------------------------- TWIN DB -----------------------------
------------------------------------------------------------------

-- place customom SQL And DDL for upgrade here (place GO before CREATE statements) 




--Aggiorno anche il Template per propagare queste allarmi anche ai nuovi impianti
-- Devo settare il DB in Read Write e per fare questo vanno 
-- tolti attributi READ ONLY ai file fisici

-- Devo settare il DB in Read Write e per fare questo vanno 
-- tolti attributi READ ONLY ai file fisici

USE master

declare @cmd varchar(4000)
declare @dbfile  varchar(500)
declare @logfile varchar(500)

select @dbfile  =RTRIM(filename) FROM _TemplateConfigDB_x.dbo.sysfiles where filename like '%_TemplateConfigDB_x.mdf%'
select @logfile =RTRIM(filename) FROM _TemplateConfigDB_x.dbo.sysfiles where filename like '%_TemplateConfigDB_x.ldf%'

set @cmd = 'ATTRIB -R "'+@dbfile + '"'
exec master.dbo.xp_cmdshell @cmd,NO_OUTPUT


set @cmd='ATTRIB -R "'+@logfile +'"'
exec master.dbo.xp_cmdshell @cmd,NO_OUTPUT

ALTER DATABASE _TemplateConfigDB_x SET READ_WRITE WITH ROLLBACK IMMEDIATE

GO

USE _TemplateConfigDB_x
GO


SET IDENTITY_INSERT Instrumentsdictionary ON

delete from Instrumentsdictionary where ID_DictInstrument between 269 and 276
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(269,221,1025,'INVENSYS WIDE SUPERMARKET','IWP 750 SM','IWP 750 SM')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(270,221,1026,'INVENSYS WIDE SUPERMARKET','IWP 760 SM','IWP 760 SM')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(271,218,1025,'INVENSYS CONTROLLERS','IC 915 LX WITH DIFFERENTIAL SET-POINT','IC 915 LX WITH DIFFERENTIAL SET-POINT')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(272,191,1037,'ID ELECTROLUX','ID 961','ID 961')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(273,191,1041,'ID ELECTROLUX','ID 974','ID 974')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(274,224,1027,'ID 985/E LX','ID 985/E LX','ID 985/E LX')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(275,202,1026,'EWDR 983 LX','EWDR 983 LX','EWDR 983 LX')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(276,132,1033,'INVENSYS CONTROLLERS','IC 915 LX/I-V','IC 915 LX/I-V C')


SET IDENTITY_INSERT  InstrumentsDictionary OFF 

-- insert of new states

delete from StatesDictionary where statecode = 841
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,0,'Frame Heater')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,34,'Frame Heater')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,39,'Resistenze antiappannanti')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,44,'Frame Heater')


GO



----------------------------------------------------------------------------------------------------
----------------------- Aggiornamento dei dati e stored procedure    -------------------------------
----------------------- nei DB Acquired/ Config  dei plant registrati -------------------------------
----------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------
-- Il Ciclo sui plants DB viene eseguito partendo dal TWIN DB 

USE TwinDB

declare @dbname as varchar(50)
declare @dbdescription as varchar(50)
declare @AcqDB as varchar(50)
declare @CfgDB as varchar(50)
declare @dbnameEx as varchar(128)
declare @dbnameCfgEx as varchar(128)
set @AcqDB = 'AcqDB'
set @CfgDB = 'CfgDB'

declare @cmd as varchar(4000)

CREATE TABLE MY_COMANDTEXT (command varchar(4000))

declare CrsPlants cursor for select name,description from TwinDB.dbo.plants
open CrsPlants
fetch next from CrsPlants into @dbname,@dbdescription

while @@FETCH_STATUS = 0
 begin 

-------------------------- Aggiornamento Plants CFG  ---------------------------------------
--
set @dbnameCfgEx = master.dbo.fc_GetRegularIdentifier(@dbname + @CfgDB)


set @cmd = 'USE ' + @dbnameCfgEx  + '
SET IDENTITY_INSERT Instrumentsdictionary ON

delete from Instrumentsdictionary where ID_DictInstrument between 269 and 276
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(269,221,1025,''INVENSYS WIDE SUPERMARKET'',''IWP 750 SM'',''IWP 750 SM'')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(270,221,1026,''INVENSYS WIDE SUPERMARKET'',''IWP 760 SM'',''IWP 760 SM'')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(271,218,1025,''INVENSYS CONTROLLERS'',''IC 915 LX WITH DIFFERENTIAL SET-POINT'',''IC 915 LX WITH DIFFERENTIAL SET-POINT'')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(272,191,1037,''ID ELECTROLUX'',''ID 961'',''ID 961'')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(273,191,1041,''ID ELECTROLUX'',''ID 974'',''ID 974'')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(274,224,1027,''ID 985/E LX'',''ID 985/E LX'',''ID 985/E LX'')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(275,202,1026,''EWDR 983 LX'',''EWDR 983 LX'',''EWDR 983 LX'')
INSERT INTO [instrumentsdictionary] ([ID_DictInstrument],[MicroFamily],[ModelCode],[FamilyName],[ModelName],[Description])VALUES(276,132,1033,''INVENSYS CONTROLLERS'',''IC 915 LX/I-V'',''IC 915 LX/I-V C'')


SET IDENTITY_INSERT  InstrumentsDictionary OFF 
'
exec (@cmd)


-- insert of new states
set @cmd = 'USE ' + @dbnameCfgEx  + '

delete from StatesDictionary where statecode = 841
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,0,''Frame Heater'')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,34,''Frame Heater'')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,39,''Resistenze antiappannanti'')
INSERT INTO [statesdictionary] ([StateCode],[CountryCode],[Description])VALUES(841,44,''Frame Heater'')
'
  exec (@cmd)


-- Aggiunta maschere 191
-- 
set @cmd = 'USE ' + @dbnameCfgEx  + '


------------------------------------------ FW MASK 191 -----------------------------------
--
delete from CompactVsTelevisAlm where FW_Mask=191
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,53,1200);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,54,1201); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,56,1000); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,57,1100); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,76,1637); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,78,1609);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,79,1621); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (191,80,1608);
'

exec (@cmd)


-- Aggiunta maschere 218
-- 
set @cmd = 'USE ' + @dbnameCfgEx  + '


------------------------------------------ FW MASK 218 -----------------------------------
--
delete from CompactVsTelevisAlm where FW_Mask=218
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,87,1000); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,88,1100); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,89,1000);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,90,1100);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,53,1200); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,54,1201); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,76,1637); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (218,79,1621); 
'

exec (@cmd)  


-- Aggiunta maschere 221
-- 
set @cmd = 'USE ' + @dbnameCfgEx  + '


------------------------------------------ FW MASK 221 -----------------------------------
--
delete from CompactVsTelevisAlm where FW_Mask=221
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,49,1600);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,53,1200);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,54,1201);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,55,1202);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,56,1000);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,57,1100);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,60,1002);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,61,1102);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,73,1603);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,76,1637);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,78,1609);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,79,1621);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,80,1608);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,82,1611);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,102,1611);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,103,1602);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,104,1601);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (221,105,1619);
'

exec (@cmd)
  

-- Aggiunta maschere 224
-- 
set @cmd = 'USE ' + @dbnameCfgEx  + '


------------------------------------------ FW MASK 224 -----------------------------------
--
delete from CompactVsTelevisAlm where FW_Mask=224
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,49,1600); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,53,1200);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,54,1201);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,55,1202);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,56,1000);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,57,1100); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,60,1002); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,61,1102); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,73,1603); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,76,1637); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,78,1609);
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,79,1621); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,80,1608); 
INSERT INTO CompactVsTelevisAlm (FW_Mask,CompactAlmCode,TelevisAlmCode) VALUES (224,82,1611); 
'

exec (@cmd)


    
  fetch next from CrsPlants into @dbname,@dbdescription
	  
 end

CLOSE CrsPlants
DEALLOCATE CrsPlants

DROP TABLE MY_COMANDTEXT 

GO

----------------------- END Aggiornamento dei dati e stored procedure -------------------------------
----------------------- nei DB Acquired/ Config  dei plant registrati  -------------------------------


------------------------------------------------------------------------------------------------------
-- Corregge il baco di comando creazione vista troppo lungo (maggiore di 8000 char) nel caso di numerosi 
-- plant (> 40!!!). In pratica viene sovrascritta la vista st_UpdateAlmViewFromPlants.
------------------------------------------------------------------------------------------------------

USE TwinDB

ALTER  PROCEDURE [st_UpdateAlmViewFromPlants] AS

declare  crsPlants cursor for
	select PlantID, [Name],[description]  from plants

declare @ptrval binary(16)
declare @PlantID int
declare @PlantName varchar(50)
declare @PlantDescr varchar(50)
declare @command varchar(8000)
declare @MyCmd1 varchar(8000) -- about 1000 char for each plant, so we must get enough space for 80 plants using 10 variables
declare @MyCmd2 varchar(8000) 
declare @MyCmd3 varchar(8000) 
declare @MyCmd4 varchar(8000) 
declare @MyCmd5 varchar(8000) 
declare @MyCmd6 varchar(8000) 
declare @MyCmd7 varchar(8000) 
declare @MyCmd8 varchar(8000) 
declare @MyCmd9 varchar(8000) 
declare @MyCmd10 varchar(8000) 
declare @PIndex smallint
set @PIndex=0
set @PlantID = -1


create table #T_CMDTEXT (Command text)
insert #T_CMDTEXT (command) values('')

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Vw_AlmCfgFromPlants]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Vw_AlmCfgFromPlants]

open crsPlants
fetch next from crsPlants into @PlantID,@PlantName,@PlantDescr

WHILE @@FETCH_STATUS = 0
	begin
		IF @PIndex=0
			BEGIN
				set @command='CREATE  VIEW [Vw_AlmCfgFromPlants] as ' + char(13)
			END
		ELSE
			BEGIN
				set @command=@command + char(13) + ' UNION ' + char(13)
			END
		set @command=@command +
			'SELECT ' + convert(varchar,@PlantID) + ' as PlantID,''' + 
			@PlantName + ' ' + isnull(replace (@PlantDescr, '''', ''''''),'') + ''' as PlantName, cfgbase.*
			FROM  [' + @PlantName +'cfgDB].dbo.Vw_VirtInstr_AlmsBase as CfgBASE '	

		set @PIndex=@PIndex+1

		set @command=@command + ' '
		SELECT top 1 @ptrval = TEXTPTR(command)  FROM #T_CMDTEXT
		UPDATETEXT #T_CMDTEXT.command @ptrval null 0 @command
		
		--update #T_CMDTEXT set command=command + ' ' + @MyCmd1
		set @command =''
		fetch next from crsPlants into @PlantID,@PlantName,@PlantDescr
	end
CLOSE crsPlants
DEALLOCATE crsPlants

select @MyCmd1=substring(command,1,8000) from #T_CMDTEXT
select @MyCmd2=substring(command,8001,8000) from #T_CMDTEXT
select @MyCmd3=substring(command,16001,8000) from #T_CMDTEXT
select @MyCmd4=substring(command,24001,8000) from #T_CMDTEXT
select @MyCmd5=substring(command,32001,8000) from #T_CMDTEXT
select @MyCmd6=substring(command,40001,8000) from #T_CMDTEXT
select @MyCmd7=substring(command,48001,8000) from #T_CMDTEXT
select @MyCmd8=substring(command,56001,8000) from #T_CMDTEXT
select @MyCmd9=substring(command,64001,8000) from #T_CMDTEXT
select @MyCmd10=substring(command,72001,8000) from #T_CMDTEXT


--print  (@MyCmd1+@MyCmd2+@MyCmd3+@MyCmd4+@MyCmd5+@MyCmd6+@MyCmd7+@MyCmd8+@MyCmd9+@MyCmd10)
--print len((@MyCmd1+@MyCmd2+@MyCmd3+@MyCmd4+@MyCmd5+@MyCmd6+@MyCmd7+@MyCmd8+@MyCmd9+@MyCmd10))
exec (@MyCmd1+@MyCmd2+@MyCmd3+@MyCmd4+@MyCmd5+@MyCmd6+@MyCmd7+@MyCmd8+@MyCmd9+@MyCmd10)

drop table #T_CMDTEXT


GO


--- Version Upgrade (user must only modify version number) 
--
USE TwinDB
UPDATE  GENERICSETTINGS SET SETVALUE='01.03.02' WHERE NAME='DB_VERSION'
GO



